`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\wb_model_defines.v"


























































`timescale 1ns / 10ps


`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\ac97_codec_sin.v"






























































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 63 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\ac97_codec_sin.v"


module ac97_codec_sin(clk, rst,

	sync,
	slt0, slt1, slt2, slt3, slt4, slt5,
	slt6, slt7, slt8, slt9, slt10, slt11, slt12,

	sdata_in
	);

input		clk, rst;



input		sync;
output	[15:0]	slt0;
output	[19:0]	slt1;
output	[19:0]	slt2;
output	[19:0]	slt3;
output	[19:0]	slt4;
output	[19:0]	slt5;
output	[19:0]	slt6;
output	[19:0]	slt7;
output	[19:0]	slt8;
output	[19:0]	slt9;
output	[19:0]	slt10;
output	[19:0]	slt11;
output	[19:0]	slt12;



input		sdata_in;






reg		sdata_in_r;
reg	[19:0]	sr;

reg	[15:0]	slt0;
reg	[19:0]	slt1;
reg	[19:0]	slt2;
reg	[19:0]	slt3;
reg	[19:0]	slt4;
reg	[19:0]	slt5;
reg	[19:0]	slt6;
reg	[19:0]	slt7;
reg	[19:0]	slt8;
reg	[19:0]	slt9;
reg	[19:0]	slt10;
reg	[19:0]	slt11;
reg	[19:0]	slt12;

wire	[12:0]	le;







reg		sync_r;
wire		sync_e;

always @(posedge clk)
	sync_r <= #1 sync;

assign sync_e = sync & !sync_r;


reg	[7:0]	cnt;

always @(posedge clk)
	if(sync_e)	cnt <= #1 0;
	else		cnt <= #1 cnt + 1;

assign le[0] = (cnt == 16);
assign le[1] = (cnt == 36);
assign le[2] = (cnt == 56);
assign le[3] = (cnt == 76);
assign le[4] = (cnt == 96);
assign le[5] = (cnt == 116);
assign le[6] = (cnt == 136);
assign le[7] = (cnt == 156);
assign le[8] = (cnt == 176);
assign le[9] = (cnt == 196);
assign le[10] = (cnt == 216);
assign le[11] = (cnt == 236);
assign le[12] = (cnt == 0);






always @(posedge clk)
	if(le[0])	slt0 <= #1 sr[15:0];

always @(posedge clk)
	if(le[1])	slt1 <= #1 sr;

always @(posedge clk)
	if(le[2])	slt2 <= #1 sr;

always @(posedge clk)
	if(le[3])	slt3 <= #1 sr;

always @(posedge clk)
	if(le[4])	slt4 <= #1 sr;

always @(posedge clk)
	if(le[5])	slt5 <= #1 sr;

always @(posedge clk)
	if(le[6])	slt6 <= #1 sr;

always @(posedge clk)
	if(le[7])	slt7 <= #1 sr;

always @(posedge clk)
	if(le[8])	slt8 <= #1 sr;

always @(posedge clk)
	if(le[9])	slt9 <= #1 sr;

always @(posedge clk)
	if(le[10])	slt10 <= #1 sr;

always @(posedge clk)
	if(le[11])	slt11 <= #1 sr;

always @(posedge clk)
	if(le[12])	slt12 <= #1 sr;






always @(negedge clk)
	sdata_in_r <= #1 sdata_in;

always @(posedge clk)
	sr <= #1 {sr[18:0], sdata_in_r };

endmodule




`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\ac97_codec_sout.v"






























































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 63 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\ac97_codec_sout.v"


module ac97_codec_sout(clk, rst,

	sync, slt0, slt1, slt2, slt3, slt4, slt5,
	slt6, slt7, slt8, slt9, slt10, slt11, slt12,

	sdata_out
	);

input		clk, rst;



input		sync;
input	[15:0]	slt0;
input	[19:0]	slt1;
input	[19:0]	slt2;
input	[19:0]	slt3;
input	[19:0]	slt4;
input	[19:0]	slt5;
input	[19:0]	slt6;
input	[19:0]	slt7;
input	[19:0]	slt8;
input	[19:0]	slt9;
input	[19:0]	slt10;
input	[19:0]	slt11;
input	[19:0]	slt12;



output		sdata_out;






reg		sdata_out_r;

reg	[15:0]	slt0_r;
reg	[19:0]	slt1_r;
reg	[19:0]	slt2_r;
reg	[19:0]	slt3_r;
reg	[19:0]	slt4_r;
reg	[19:0]	slt5_r;
reg	[19:0]	slt6_r;
reg	[19:0]	slt7_r;
reg	[19:0]	slt8_r;
reg	[19:0]	slt9_r;
reg	[19:0]	slt10_r;
reg	[19:0]	slt11_r;
reg	[19:0]	slt12_r;

reg		sync_r;
wire		sync_e;







always @(posedge clk)
	sync_r <= #1 sync;

assign sync_e = sync & !sync_r;













assign	sdata_out = slt0_r[15];

always @(posedge clk)
	if(sync_e)	slt0_r <= #1 slt0;
	else		slt0_r <= #1 {slt0_r[14:0], slt1_r[19]};

always @(posedge clk)
	if(sync_e)	slt1_r <= #1 slt1;
	else		slt1_r <= #1 {slt1_r[18:0], slt2_r[19]};

always @(posedge clk)
	if(sync_e)	slt2_r <= #1 slt2;
	else		slt2_r <= #1 {slt2_r[18:0], slt3_r[19]};

always @(posedge clk)
	if(sync_e)	slt3_r <= #1 slt3;
	else		slt3_r <= #1 {slt3_r[18:0], slt4_r[19]};

always @(posedge clk)
	if(sync_e)	slt4_r <= #1 slt4;
	else		slt4_r <= #1 {slt4_r[18:0], slt5_r[19]};

always @(posedge clk)
	if(sync_e)	slt5_r <= #1 slt5;
	else		slt5_r <= #1 {slt5_r[18:0], slt6_r[19]};

always @(posedge clk)
	if(sync_e)	slt6_r <= #1 slt6;
	else		slt6_r <= #1 {slt6_r[18:0], slt7_r[19]};

always @(posedge clk)
	if(sync_e)	slt7_r <= #1 slt7;
	else		slt7_r <= #1 {slt7_r[18:0], slt8_r[19]};

always @(posedge clk)
	if(sync_e)	slt8_r <= #1 slt8;
	else		slt8_r <= #1 {slt8_r[18:0], slt9_r[19]};

always @(posedge clk)
	if(sync_e)	slt9_r <= #1 slt9;
	else		slt9_r <= #1 {slt9_r[18:0], slt10_r[19]};

always @(posedge clk)
	if(sync_e)	slt10_r <= #1 slt10;
	else		slt10_r <= #1 {slt10_r[18:0], slt11_r[19]};

always @(posedge clk)
	if(sync_e)	slt11_r <= #1 slt11;
	else		slt11_r <= #1 {slt11_r[18:0], slt12_r[19]};

always @(posedge clk)
	if(sync_e)	slt12_r <= #1 slt12;
	else		slt12_r <= #1 {slt12_r[18:0], 1'b0 };


endmodule



`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\ac97_codec_top.v"





























































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 62 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\ac97_codec_top.v"


module ac97_codec_top(clk, rst,
	sync,
	sdata_out,
	sdata_in
	);

input		clk, rst;



input		sync;
output		sdata_out;
input		sdata_in;






wire	[15:0]	out_slt0;
wire	[19:0]	out_slt1;
wire	[19:0]	out_slt2;
wire	[19:0]	out_slt3;
wire	[19:0]	out_slt4;
wire	[19:0]	out_slt5;
wire	[19:0]	out_slt6;
wire	[19:0]	out_slt7;
wire	[19:0]	out_slt8;
wire	[19:0]	out_slt9;
wire	[19:0]	out_slt10;
wire	[19:0]	out_slt11;
wire	[19:0]	out_slt12;

wire	[15:0]	in_slt0;
wire	[19:0]	in_slt1;
reg	[19:0]	in_slt2;
reg	[19:0]	in_slt3;
reg	[19:0]	in_slt4;
reg	[19:0]	in_slt5;
reg	[19:0]	in_slt6;
reg	[19:0]	in_slt7;
reg	[19:0]	in_slt8;
reg	[19:0]	in_slt9;
reg	[19:0]	in_slt10;
reg	[19:0]	in_slt11;
reg	[19:0]	in_slt12;

reg	[19:0]	smem[0:32];
reg	[19:0]	rmem[0:32];

reg	[15:0]	s0;
reg	[19:0]	s1;

integer		rs1_ptr, rs2_ptr;
integer		rs3_ptr, rs4_ptr, rs5_ptr, rs6_ptr, rs7_ptr;
integer		rs8_ptr, rs9_ptr, rs10_ptr, rs11_ptr, rs12_ptr;
integer		is2_ptr, is3_ptr, is4_ptr, is5_ptr, is6_ptr, is7_ptr;
integer		is8_ptr, is9_ptr, is10_ptr, is11_ptr, is12_ptr;
 
reg	[19:0]	rslt0;
reg	[19:0]	rslt1;
reg	[19:0]	rslt2;
reg	[19:0]	rs1_mem[0:256];
reg	[19:0]	rs2_mem[0:256];
reg	[19:0]	rs3_mem[0:256];
reg	[19:0]	rs4_mem[0:256];
reg	[19:0]	rs5_mem[0:256];
reg	[19:0]	rs6_mem[0:256];
reg	[19:0]	rs7_mem[0:256];
reg	[19:0]	rs8_mem[0:256];
reg	[19:0]	rs9_mem[0:256];
reg	[19:0]	rs10_mem[0:256];
reg	[19:0]	rs11_mem[0:256];
reg	[19:0]	rs12_mem[0:256];

reg	[19:0]	is2_mem[0:256];
reg	[19:0]	is3_mem[0:256];
reg	[19:0]	is4_mem[0:256];
reg	[19:0]	is5_mem[0:256];
reg	[19:0]	is6_mem[0:256];
reg	[19:0]	is7_mem[0:256];
reg	[19:0]	is8_mem[0:256];
reg	[19:0]	is9_mem[0:256];
reg	[19:0]	is10_mem[0:256];
reg	[19:0]	is11_mem[0:256];
reg	[19:0]	is12_mem[0:256];






task init;
input	mode;

integer	mode;
begin

fill_mem(mode);
clr_ptrs;

end
endtask

task fill_mem;
input	mode;

integer	mode;
integer n;

begin

if(mode==0)
for(n=0;n<256;n=n+1)
   begin
	is2_mem[n] = { 4'h0, n[11:0], 4'h0 };
	is3_mem[n] = { 4'h1, n[11:0], 4'h0 };
	is4_mem[n] = { 4'h2, n[11:0], 4'h0 };
	is5_mem[n] = { 4'h3, n[11:0], 4'h0 };
	is6_mem[n] = { 4'h4, n[11:0], 4'h0 };
	is7_mem[n] = { 4'h5, n[11:0], 4'h0 };
	is8_mem[n] = { 4'h6, n[11:0], 4'h0 };
	is9_mem[n] = { 4'h7, n[11:0], 4'h0 };
	is10_mem[n] = { 4'h8, n[11:0], 4'h0 };
	is11_mem[n] = { 4'h9, n[11:0], 4'h0 };
	is12_mem[n] = { 4'ha, n[11:0], 4'h0 };
   end
else
for(n=0;n<256;n=n+1)
   begin
	is2_mem[n] = $random;
	is3_mem[n] = $random;
	is4_mem[n] = $random;
	is5_mem[n] = $random;
	is6_mem[n] = $random;
	is7_mem[n] = $random;
	is8_mem[n] = $random;
	is9_mem[n] = $random;
	is10_mem[n] = $random;
	is11_mem[n] = $random;
	is12_mem[n] = $random;
   end

end
endtask

always @(posedge clk)
	if(!rst)	s0 = 0;

always @(posedge clk)
	if(!rst)	s1 = 0;

assign in_slt0  = s0;
assign in_slt1  = s1;



always @(rslt0 or rslt1 or s0)
	if(s0[13] | (rslt0[14] & rslt1[19]) )
	   begin
		in_slt2 = #1 is2_mem[is2_ptr];
		is2_ptr = is2_ptr + 1;
	   end

always @(posedge sync)
	if(s0[12])
	   begin
		in_slt3 = #1 is3_mem[is3_ptr];
		is3_ptr = is3_ptr + 1;
	   end

always @(posedge sync)
	if(s0[11])
	   begin
		in_slt4 = #1 is4_mem[is4_ptr];
		is4_ptr = is4_ptr + 1;
	   end

always @(posedge sync)
	if(s0[10])
	   begin
		in_slt5 = #1 is5_mem[is5_ptr];
		is5_ptr = is5_ptr + 1;
	   end

always @(posedge sync)
	if(s0[9])
	   begin
		in_slt6 = #1 is6_mem[is6_ptr];
		is6_ptr = is6_ptr + 1;
	   end

always @(posedge sync)
	if(s0[8])
	   begin
		in_slt7 = #1 is7_mem[is7_ptr];
		is7_ptr = is7_ptr + 1;
	   end

always @(posedge sync)
	if(s0[7])
	   begin
		in_slt8 = #1 is8_mem[is8_ptr];
		is8_ptr = is8_ptr + 1;
	   end

always @(posedge sync)
	if(s0[6])
	   begin
		in_slt9 = #1 is9_mem[is9_ptr];
		is9_ptr = is9_ptr + 1;
	   end

always @(posedge sync)
	if(s0[5])
	   begin
		in_slt10 = #1 is10_mem[is10_ptr];
		is10_ptr = is10_ptr + 1;
	   end

always @(posedge sync)
	if(s0[4])
	   begin
		in_slt11 = #1 is11_mem[is11_ptr];
		is11_ptr = is11_ptr + 1;
	   end

always @(posedge sync)
	if(s0[3])
	   begin
		in_slt12 = #1 is12_mem[is12_ptr];
		is12_ptr = is12_ptr + 1;
	   end

always @(posedge sync)
   begin
	rslt0 <= #2 out_slt0;
	rslt1 <= #2 out_slt1;
	rslt2 <= #2 out_slt2;
   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[14])
	   begin
		rs1_mem[rs1_ptr] = #1 out_slt1;
		rs1_ptr = rs1_ptr + 1;
		
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[13])
	   begin
		rs2_mem[rs2_ptr] = #1 out_slt2;
		rs2_ptr = rs2_ptr + 1;
		
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[12])
	   begin
		rs3_mem[rs3_ptr] = #1 out_slt3;
		rs3_ptr = rs3_ptr + 1;
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[11])
	   begin
		rs4_mem[rs4_ptr] = #1 out_slt4;
		rs4_ptr = rs4_ptr + 1;
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[10])
	   begin
		rs5_mem[rs5_ptr] = #1 out_slt5;
		rs5_ptr = rs5_ptr + 1;
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[9])
	   begin
		rs6_mem[rs6_ptr] = #1 out_slt6;
		rs6_ptr = rs6_ptr + 1;
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[8])
	   begin
		rs7_mem[rs7_ptr] = #1 out_slt7;
		rs7_ptr = rs7_ptr + 1;
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[7])
	   begin
		rs8_mem[rs8_ptr] = #1 out_slt8;
		rs8_ptr = rs8_ptr + 1;
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[6])
	   begin
		rs9_mem[rs9_ptr] = #1 out_slt9;
		rs9_ptr = rs9_ptr + 1;
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[5])
	   begin
		rs10_mem[rs10_ptr] = #1 out_slt10;
		rs10_ptr = rs10_ptr + 1;
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[4])
	   begin
		rs11_mem[rs11_ptr] = #1 out_slt11;
		rs11_ptr = rs11_ptr + 1;
	   end

always @(posedge sync)
	if(out_slt0[15] & out_slt0[3])
	   begin
		rs12_mem[rs12_ptr] = #1 out_slt12;
		rs12_ptr = rs12_ptr + 1;
	   end


task clr_ptrs;

begin

rs1_ptr = 0;
rs2_ptr = 0;
rs3_ptr = 0;
rs4_ptr = 0;
rs5_ptr = 0;
rs6_ptr = 0;
rs7_ptr = 0;
rs8_ptr = 0;
rs9_ptr = 0;
rs10_ptr = 0;
rs11_ptr = 0;
rs12_ptr = 0;

is2_ptr = 0;
is3_ptr = 0;
is4_ptr = 0;
is5_ptr = 0;
is6_ptr = 0;
is7_ptr = 0;
is8_ptr = 0;
is9_ptr = 0;
is10_ptr = 0;
is11_ptr = 0;
is12_ptr = 0;

end
endtask


task set_tag;
input		cr;
input	[11:0]	tag;





begin
s0 = {cr, tag, 3'h0};
end
endtask


task set_req;
input	[9:0]	req;

reg	[6:0]	idx;
begin

idx = out_slt1[18:12];
s1 = {1'b0, idx, ~req, 2'h0};

end
endtask


task tx1;
input	fcnt_max;	
input	rdy_del;	
input	ovalid;		
input	ivalid;		
input	oint;		
input	iint;		

integer		fcnt_max, f;
integer		rdy_del;
reg	[9:0]	ovalid, ivalid;
reg	[19:0]	oint, iint;

reg		och0_v;
reg	[1:0]	och0_cnt;
reg		och1_v;
reg	[1:0]	och1_cnt;
reg		och2_v;
reg	[1:0]	och2_cnt;
reg		och3_v;
reg	[1:0]	och3_cnt;
reg		och4_v;
reg	[1:0]	och4_cnt;
reg		och5_v;
reg	[1:0]	och5_cnt;
reg		och6_v;
reg	[1:0]	och6_cnt;
reg		och7_v;
reg	[1:0]	och7_cnt;
reg		och8_v;
reg	[1:0]	och8_cnt;
reg		och9_v;
reg	[1:0]	och9_cnt;
reg		ich0_v;
reg	[1:0]	ich0_cnt;
reg		ich1_v;
reg	[1:0]	ich1_cnt;
reg		ich2_v;
reg	[1:0]	ich2_cnt;
reg		ich3_v;
reg	[1:0]	ich3_cnt;
reg		ich4_v;
reg	[1:0]	ich4_cnt;
reg		ich5_v;
reg	[1:0]	ich5_cnt;
reg		ich6_v;
reg	[1:0]	ich6_cnt;
reg		ich7_v;
reg	[1:0]	ich7_cnt;
reg		ich8_v;
reg	[1:0]	ich8_cnt;
reg		ich9_v;
reg	[1:0]	ich9_cnt;

begin

och0_cnt = 0;
och1_cnt = 0;
och2_cnt = 0;
och3_cnt = 0;
och4_cnt = 0;
och5_cnt = 0;
och6_cnt = 0;
och7_cnt = 0;
och8_cnt = 0;
och9_cnt = 0;

ich0_cnt = 0;
ich1_cnt = 0;
ich2_cnt = 0;
ich3_cnt = 0;
ich4_cnt = 0;
ich5_cnt = 0;
ich6_cnt = 0;
ich7_cnt = 0;
ich8_cnt = 0;
ich9_cnt = 0;

for(f=0;f<fcnt_max;f=f+1)
   begin
	while(!sync)	@(posedge clk);
	if(f>rdy_del)
	   begin

		och0_v = ovalid[9] & (och0_cnt == oint[19:18]);
		if(och0_v)	och0_cnt = 0;
		else		och0_cnt = och0_cnt + 1;
		och1_v = ovalid[8] & (och1_cnt == oint[17:16]);
		if(och1_v)	och1_cnt = 0;
		else		och1_cnt = och1_cnt + 1;
		och2_v = ovalid[7] & (och2_cnt == oint[15:14]);
		if(och2_v)	och2_cnt = 0;
		else		och2_cnt = och2_cnt + 1;
		och3_v = ovalid[6] & (och3_cnt == oint[13:12]);
		if(och3_v)	och3_cnt = 0;
		else		och3_cnt = och3_cnt + 1;
		och4_v = ovalid[5] & (och4_cnt == oint[11:10]);
		if(och4_v)	och4_cnt = 0;
		else		och4_cnt = och4_cnt + 1;
		och5_v = ovalid[4] & (och5_cnt == oint[9:8]);
		if(och5_v)	och5_cnt = 0;
		else		och5_cnt = och5_cnt + 1;
		och6_v = ovalid[3] & (och6_cnt == oint[7:6]);
		if(och6_v)	och6_cnt = 0;
		else		och6_cnt = och6_cnt + 1;
		och7_v = ovalid[2] & (och7_cnt == oint[5:4]);
		if(och7_v)	och7_cnt = 0;
		else		och7_cnt = och7_cnt + 1;
		och8_v = ovalid[1] & (och8_cnt == oint[3:2]);
		if(och8_v)	och8_cnt = 0;
		else		och8_cnt = och8_cnt + 1;
		och9_v = ovalid[0] & (och9_cnt == oint[1:0]);
		if(och9_v)	och9_cnt = 0;
		else		och9_cnt = och9_cnt + 1;

		ich0_v = ivalid[9] & (ich0_cnt == iint[19:18]);
		if(ich0_v)	ich0_cnt = 0;
		else		ich0_cnt = ich0_cnt + 1;
		ich1_v = ivalid[8] & (ich1_cnt == iint[17:16]);
		if(ich1_v)	ich1_cnt = 0;
		else		ich1_cnt = ich1_cnt + 1;
		ich2_v = ivalid[7] & (ich2_cnt == iint[15:14]);
		if(ich2_v)	ich2_cnt = 0;
		else		ich2_cnt = ich2_cnt + 1;
		ich3_v = ivalid[6] & (ich3_cnt == iint[13:12]);
		if(ich3_v)	ich3_cnt = 0;
		else		ich3_cnt = ich3_cnt + 1;
		ich4_v = ivalid[5] & (ich4_cnt == iint[11:10]);
		if(ich4_v)	ich4_cnt = 0;
		else		ich4_cnt = ich4_cnt + 1;
		ich5_v = ivalid[4] & (ich5_cnt == iint[9:8]);
		if(ich5_v)	ich5_cnt = 0;
		else		ich5_cnt = ich5_cnt + 1;
		ich6_v = ivalid[3] & (ich6_cnt == iint[7:6]);
		if(ich6_v)	ich6_cnt = 0;
		else		ich6_cnt = ich6_cnt + 1;
		ich7_v = ivalid[2] & (ich7_cnt == iint[5:4]);
		if(ich7_v)	ich7_cnt = 0;
		else		ich7_cnt = ich7_cnt + 1;
		ich8_v = ivalid[1] & (ich8_cnt == iint[3:2]);
		if(ich8_v)	ich8_cnt = 0;
		else		ich8_cnt = ich8_cnt + 1;
		ich9_v = ivalid[0] & (ich9_cnt == iint[1:0]);
		if(ich9_v)	ich9_cnt = 0;
		else		ich9_cnt = ich9_cnt + 1;

		set_tag(1'b1, { 1'b0,		
				1'b0,		
				ich0_v, ich1_v, ich2_v, ich3_v, ich4_v,
				ich5_v, ich6_v, ich7_v, ich8_v, ich9_v} );

		set_req( {	och0_v, och1_v, och2_v, och3_v, och4_v,
				och5_v, och6_v, och7_v, och8_v, och9_v} );

	   end
	while(sync)	@(posedge clk);
   end
end
endtask






ac97_codec_sin	u0(
		.clk(		clk		),
		.rst(		rst		),
		.sync(		sync		),
		.slt0(		out_slt0	),
		.slt1(		out_slt1	),
		.slt2(		out_slt2	),
		.slt3(		out_slt3	),
		.slt4(		out_slt4	),
		.slt5(		out_slt5	),
		.slt6(		out_slt6	),
		.slt7(		out_slt7	),
		.slt8(		out_slt8	),
		.slt9(		out_slt9	),
		.slt10(		out_slt10	),
		.slt11(		out_slt11	),
		.slt12(		out_slt12	),
		.sdata_in(	sdata_in	)
		);

ac97_codec_sout	u1(
		.clk(		clk		),
		.rst(		rst		),
		.sync(		sync		),
		.slt0(		in_slt0		),
		.slt1(		in_slt1		),
		.slt2(		in_slt2		),
		.slt3(		in_slt3		),
		.slt4(		in_slt4		),
		.slt5(		in_slt5		),
		.slt6(		in_slt6		),
		.slt7(		in_slt7		),
		.slt8(		in_slt8		),
		.slt9(		in_slt9		),
		.slt10(		in_slt10	),
		.slt11(		in_slt11	),
		.slt12(		in_slt12	),
		.sdata_out(	sdata_out	)
		);

endmodule




`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\test_bench_top.v"






































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 71 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\test_bench_top.v"


module test;

reg		clk;
reg		rst;
wire	[31:0]	wb_data_i;
wire	[31:0]	wb_data_o;
wire	[31:0]	wb_addr_i;
wire	[3:0]	wb_sel_i;
wire		wb_we_i;
wire		wb_cyc_i;
wire		wb_stb_i;
wire		wb_ack_o;
wire		wb_err_o;
wire		int;
wire	[8:0]	dma_req;
reg	[8:0]	dma_ack;
reg		susp_req;
reg		resume_req;
wire		suspended;
reg		bit_clk;
wire		sync;
wire		sdata_out;
wire		sdata_in;
wire		ac97_reset_;


reg		verbose;
integer		error_cnt;


reg		wb_busy;
reg		oc0_dma_en;
reg		oc1_dma_en;
reg		oc2_dma_en;
reg		oc3_dma_en;
reg		oc4_dma_en;
reg		oc5_dma_en;
reg		ic0_dma_en;
reg		ic1_dma_en;
reg		ic2_dma_en;
reg	[31:0]	oc0_mem[0:256];
reg	[31:0]	oc1_mem[0:256];
reg	[31:0]	oc2_mem[0:256];
reg	[31:0]	oc3_mem[0:256];
reg	[31:0]	oc4_mem[0:256];
reg	[31:0]	oc5_mem[0:256];
reg	[31:0]	ic0_mem[0:256];
reg	[31:0]	ic1_mem[0:256];
reg	[31:0]	ic2_mem[0:256];
reg	[31:0]	reg_mem[0:256];
integer		oc0_ptr;
integer		oc1_ptr;
integer		oc2_ptr;
integer		oc3_ptr;
integer		oc4_ptr;
integer		oc5_ptr;
integer		ic0_ptr;
integer		ic1_ptr;
integer		ic2_ptr;

integer		oc0_th;
integer		oc1_th;
integer		oc2_th;
integer		oc3_th;
integer		oc4_th;
integer		oc5_th;
integer		ic0_th;
integer		ic1_th;
integer		ic2_th;

reg	[31:0]	ints_r;
reg		int_chk_en;
reg		int_ctrl_en;
integer		int_cnt;

integer		n;


reg	[31:0]	data;
reg	[31:0]	data1;
reg	[31:0]	data2;
reg	[31:0]	tmp;
integer		size, frames, m, p;





























task do_rst;

begin
	wb_busy = 0;
	oc0_dma_en = 0;
	oc1_dma_en = 0;
	oc2_dma_en = 0;
	oc3_dma_en = 0;
	oc4_dma_en = 0;
	oc5_dma_en = 0;
	ic0_dma_en = 0;
	ic1_dma_en = 0;
	ic2_dma_en = 0;

	oc0_ptr = 0;
	oc1_ptr = 0;
	oc2_ptr = 0;
	oc3_ptr = 0;
	oc4_ptr = 0;
	oc5_ptr = 0;
	ic0_ptr = 0;
	ic1_ptr = 0;
	ic2_ptr = 0;

   	rst = 0;
   	repeat(48)	@(posedge clk);
   	rst = 1;
   	repeat(48)	@(posedge clk);

end

endtask

initial
   begin
	$display("\n\n");
	$display("*****************************************************");
	$display("* WISHBONE Memory Controller Simulation started ... *");
	$display("*****************************************************");
	$display("\n");





	
	int_chk_en = 1;
	int_ctrl_en = 0;
	int_cnt = 0;
	error_cnt = 0;
   	clk = 1;
	bit_clk = 0;
   	rst = 0;
	susp_req = 0;
	resume_req = 0;
	verbose = 1;
	dma_ack = 0;

	wb_busy = 0;
	oc0_dma_en = 0;
	oc1_dma_en = 0;
	oc2_dma_en = 0;
	oc3_dma_en = 0;
	oc4_dma_en = 0;
	oc5_dma_en = 0;
	ic0_dma_en = 0;
	ic1_dma_en = 0;
	ic2_dma_en = 0;

	oc0_ptr = 0;
	oc1_ptr = 0;
	oc2_ptr = 0;
	oc3_ptr = 0;
	oc4_ptr = 0;
	oc5_ptr = 0;
	ic0_ptr = 0;
	ic1_ptr = 0;
	ic2_ptr = 0;


	oc0_th = 4;
	oc1_th = 4;
	oc2_th = 4;
	oc3_th = 4;
	oc4_th = 4;
	oc5_th = 4;
	ic0_th = 4;
	ic1_th = 4;
	ic2_th = 4;


































   	repeat(48)	@(posedge clk);
   	rst = 1;
   	repeat(48)	@(posedge clk);

	

if(1)	
   begin
$display(" ......................................................");
$display(" :                                                    :");
$display(" :    Regression Run ...                              :");
$display(" :....................................................:");

	basic1;

	do_rst;

	basic2;

	do_rst;

	vsr1;

	vsr_int;

   end
else
if(1)	
   begin
$display(" ......................................................");
$display(" :                                                    :");
$display(" :    Test Debug Testing ...                          :");
$display(" :....................................................:");

	

	

	

	

	

	vsr_int;

	repeat(100)	@(posedge clk);
	$finish;
   end
else
   begin

	
	
	

$display("\n\n");
$display("*****************************************************");
$display("*** XXX AC97 I/O Test ...                         ***");
$display("*****************************************************\n");


	wb_busy = 1;
	m0.wb_wr1( 8'h14,4'hf, 32'h0000_0003);
	m0.wb_wr1( 8'h04,4'hf, 32'h7373_7373);
	m0.wb_wr1( 8'h08,4'hf, 32'h0000_7373);
	m0.wb_wr1( 8'h0c,4'hf, 32'h0073_7373);
	m0.wb_wr1( 8'h04,4'hf, 32'h7272_7272);
	m0.wb_wr1( 8'h08,4'hf, 32'h0000_7272);

	wb_busy = 0;
	oc0_dma_en = 1;
	oc1_dma_en = 1;
	oc2_dma_en = 1;
	oc3_dma_en = 1;
	oc4_dma_en = 1;
	oc5_dma_en = 1;
	ic0_dma_en = 1;
	ic1_dma_en = 1;
	ic2_dma_en = 1;

	for(n=0;n<256;n=n+1)
	   begin
		oc0_mem[n] = $random;
		oc1_mem[n] = $random;
		oc2_mem[n] = $random;
		oc3_mem[n] = $random;
		oc4_mem[n] = $random;
		oc5_mem[n] = $random;
		ic0_mem[n] = $random;
		ic1_mem[n] = $random;
		ic2_mem[n] = $random;
	   end

	u1.init(0);
	frames = 139;

fork
	u1.tx1(	frames,					
		0,					
		10'b1111_1111_11,			
		10'b1111_1111_11,			
		20'b00_00_00_00_00_00_00_00_00_00,	
		20'b00_00_00_00_00_00_00_00_00_00	
		);

	begin	
		repeat(2)	@(posedge sync);

		for(n=0;n<75;n=n+1)
		   begin
			@(negedge sync);
			repeat(230)	@(posedge bit_clk);

			repeat(n)	@(posedge bit_clk);

			while(wb_busy)	@(posedge clk);
			wb_busy = 1;
			m0.wb_wr1( 8'h10,4'hf, {1'b1, 8'h0, n[6:0], 16'h1234 + n[7:0]} );
			wb_busy = 0;

			while(!int)	@(posedge clk);

			while(wb_busy)	@(posedge clk);
			wb_busy = 1;
			m0.wb_rd1( 8'h10,4'hf, reg_mem[n] );
			m0.wb_wr1( 8'h00, 4'hf, 32'h0000_0001);

			repeat(10)	@(posedge clk);
			force bit_clk = 0;
			repeat(80)	@(posedge clk);

			m0.wb_wr1( 8'h00, 4'hf, 32'h0000_0002);

			repeat(300)	@(posedge clk);

			release bit_clk;

			wb_busy = 0;

		   end
	end
join

repeat(300)	@(posedge bit_clk);

	for(n=0;n<75;n=n+1)
	   begin

			tmp = u1.is2_mem[n];
			data2 = {16'h0, tmp[19:4]};
			tmp = reg_mem[n];
			data1 = {16'h0, tmp[15:0]};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Register Read Data %0d Mismatch Expected: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end

	   end

	size = frames - 4;

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs3_mem[n];
		data = oc0_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH0 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs4_mem[n];
		data = oc1_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH1 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs6_mem[n];
		data = oc2_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH2 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs7_mem[n];
		data = oc3_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH3 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs8_mem[n];
		data = oc4_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH4 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs9_mem[n];
		data = oc5_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH5 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is3_mem[n];
		data = ic0_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH0 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is4_mem[n];
		data = ic1_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH1 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is6_mem[n];
		data = ic2_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH2 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");


repeat(6000)	@(posedge clk);
$finish;

   end

   	repeat(100)	@(posedge clk);
   	$finish;
   end


task wait_sync;

begin

while(!sync)	@(posedge bit_clk);
repeat(2)	@(posedge bit_clk);
end
endtask






always @(posedge clk)
begin
if(int & int_chk_en)
   begin
	while(wb_busy)	@(posedge clk);
	wb_busy = 1;
	m0.wb_rd1( 8'h18,4'hf, ints_r);
	
	wb_busy = 0;
	int_cnt = int_cnt + 1;
   end
if(int & int_ctrl_en)
   begin

	while(wb_busy)	@(posedge clk);
	wb_busy = 1;
	m0.wb_rd1( 8'h18,4'hf, ints_r);
	

	out_chan_int_handl(ints_r[04:02],0);
	out_chan_int_handl(ints_r[07:05],1);
	out_chan_int_handl(ints_r[10:08],2);
	out_chan_int_handl(ints_r[13:11],3);
	out_chan_int_handl(ints_r[16:14],4);
	out_chan_int_handl(ints_r[19:17],5);

	in_chan_int_handl(ints_r[22:20],0);
	in_chan_int_handl(ints_r[25:23],1);
	in_chan_int_handl(ints_r[28:26],2);

	m0.wb_rd1( 8'h18,4'hf, ints_r);
	wb_busy = 0;
	int_cnt = int_cnt + 1;
   end
end


task out_chan_int_handl;
input	[2:0]	int_r;
input		ch;

reg	[2:0]	int_r;
integer		ch;
integer		p;

begin

	if(int_r[0])	
	   begin
		case(ch)
		0: begin
			for(p=0;p<oc0_th;p=p+1)
				m0.wb_wr1( 8'h20,4'hf, oc0_mem[oc0_ptr+p]	);
			oc0_ptr = oc0_ptr + oc0_th;
		   end
		1: begin
			for(p=0;p<oc1_th;p=p+1)
				m0.wb_wr1( 8'h24,4'hf, oc1_mem[oc1_ptr+p]	);
			oc1_ptr = oc1_ptr + oc1_th;
		   end
		2: begin
			for(p=0;p<oc2_th;p=p+1)
				m0.wb_wr1( 8'h28,4'hf, oc2_mem[oc2_ptr+p]	);
			oc2_ptr = oc2_ptr + oc2_th;
		   end
		3: begin
			for(p=0;p<oc3_th;p=p+1)
				m0.wb_wr1( 8'h2c,4'hf, oc3_mem[oc3_ptr+p]	);
			oc3_ptr = oc3_ptr + oc3_th;
		   end
		4: begin
			for(p=0;p<oc4_th;p=p+1)
				m0.wb_wr1( 8'h30,4'hf, oc4_mem[oc4_ptr+p]	);
			oc4_ptr = oc4_ptr + oc4_th;
		   end
		5: begin
			for(p=0;p<oc5_th;p=p+1)
				m0.wb_wr1( 8'h34,4'hf, oc5_mem[oc5_ptr+p]	);
			oc5_ptr = oc5_ptr + oc5_th;
		   end
		endcase
	   end
	if(int_r[1])	
		$display("ERROR: Output Channel %0d FIFO Underrun", ch);

	if(int_r[2])	
		$display("ERROR: Output Channel %0d FIFO Ovverun", ch);
end
endtask



task in_chan_int_handl;
input	[2:0]	int_r;
input		ch;

reg	[2:0]	int_r;
integer		ch;
integer		p;

begin
	if(int_r[0])	
	   begin
		case(ch)
		0: begin
			for(p=0;p<ic0_th;p=p+1)
				m0.wb_rd1( 8'h38,4'hf, ic0_mem[ic0_ptr+p]	);
			ic0_ptr = ic0_ptr + ic0_th;
		   end
		1: begin
			for(p=0;p<ic1_th;p=p+1)
				m0.wb_rd1( 8'h3c,4'hf, ic1_mem[ic1_ptr+p]	);
			ic1_ptr = ic1_ptr + ic1_th;
		   end
		2: begin
			for(p=0;p<ic2_th;p=p+1)
				m0.wb_rd1( 8'h40,4'hf, ic2_mem[ic2_ptr+p]	);
			ic2_ptr = ic2_ptr + ic2_th;
		   end
		endcase
	   end
	if(int_r[1])	
		$display("ERROR: Input Channel %0d FIFO Underrun", ch);

	if(int_r[2])	
		$display("ERROR: Input Channel %0d FIFO Ovverun", ch);
end
endtask








always @(posedge clk)
if(oc0_dma_en & dma_req[0])
   begin
	while(wb_busy)	@(posedge clk);
	wb_busy = 1;

	for(p=0;p<oc0_th;p=p+1)
		m0.wb_wr1( 8'h20,4'hf, oc0_mem[oc0_ptr+p]	);
	oc0_ptr = oc0_ptr + oc0_th;

	wb_busy = 0;
	dma_ack[0] = 1;
	@(posedge clk);
	#1 dma_ack[0] = 0;
   end


always @(posedge clk)
if(oc1_dma_en & dma_req[1])
   begin
	while(wb_busy)	@(posedge clk);
	wb_busy = 1;
	for(p=0;p<oc1_th;p=p+1)
		m0.wb_wr1( 8'h24,4'hf, oc1_mem[oc1_ptr+p]	);
	oc1_ptr = oc1_ptr + oc1_th;
	wb_busy = 0;
	dma_ack[1] = 1;
	@(posedge clk);
	#1 dma_ack[1] = 0;
   end

always @(posedge clk)
if(oc2_dma_en & dma_req[2])
   begin
	while(wb_busy)	@(posedge clk);
	wb_busy = 1;
	for(p=0;p<oc2_th;p=p+1)
		m0.wb_wr1( 8'h28,4'hf, oc2_mem[oc2_ptr+p]	);
	oc2_ptr = oc2_ptr + oc2_th;
	wb_busy = 0;
	dma_ack[2] = 1;
	@(posedge clk);
	#1 dma_ack[2] = 0;
   end

always @(posedge clk)
if(oc3_dma_en & dma_req[3])
   begin
	while(wb_busy)	@(posedge clk);
	wb_busy = 1;
	for(p=0;p<oc3_th;p=p+1)
		m0.wb_wr1( 8'h2c,4'hf, oc3_mem[oc3_ptr+p]	);
	oc3_ptr = oc3_ptr + oc3_th;
	wb_busy = 0;
	dma_ack[3] = 1;
	@(posedge clk);
	#1 dma_ack[3] = 0;
   end

always @(posedge clk)
if(oc4_dma_en & dma_req[4])
   begin
	while(wb_busy)	@(posedge clk);
	wb_busy = 1;
	for(p=0;p<oc4_th;p=p+1)
		m0.wb_wr1( 8'h30,4'hf, oc4_mem[oc4_ptr+p]	);
	oc4_ptr = oc4_ptr + oc4_th;
	wb_busy = 0;
	dma_ack[4] = 1;
	@(posedge clk);
	#1 dma_ack[4] = 0;
   end

always @(posedge clk)
if(oc5_dma_en & dma_req[5])
   begin
	while(wb_busy)	@(posedge clk);
	wb_busy = 1;
	for(p=0;p<oc5_th;p=p+1)
		m0.wb_wr1( 8'h34,4'hf, oc5_mem[oc5_ptr+p]	);
	oc5_ptr = oc5_ptr + oc5_th;
	wb_busy = 0;
	dma_ack[5] = 1;
	@(posedge clk);
	#1 dma_ack[5] = 0;
   end

always @(posedge clk)
if(ic0_dma_en & dma_req[6])
   begin
	while(wb_busy)	@(posedge clk);
	wb_busy = 1;
	for(p=0;p<ic0_th;p=p+1)
		m0.wb_rd1( 8'h38,4'hf, ic0_mem[ic0_ptr+p]	);
	ic0_ptr = ic0_ptr + ic0_th;
	wb_busy = 0;
	dma_ack[6] = 1;
	@(posedge clk);
	#1 dma_ack[6] = 0;
   end

always @(posedge clk)
if(ic1_dma_en & dma_req[7])
   begin
	while(wb_busy)	@(posedge clk);
	wb_busy = 1;
	for(p=0;p<ic1_th;p=p+1)
		m0.wb_rd1( 8'h3c,4'hf, ic1_mem[ic1_ptr+p]	);
	ic1_ptr = ic1_ptr + ic1_th;
	wb_busy = 0;
	dma_ack[7] = 1;
	@(posedge clk);
	#1 dma_ack[7] = 0;
   end

always @(posedge clk)
if(ic2_dma_en & dma_req[8])
   begin
	while(wb_busy)	@(posedge clk);
	wb_busy = 1;
	for(p=0;p<ic2_th;p=p+1)
		m0.wb_rd1( 8'h40,4'hf, ic2_mem[ic2_ptr+p]	);
	ic2_ptr = ic2_ptr + ic2_th;
	wb_busy = 0;
	dma_ack[8] = 1;
	@(posedge clk);
	#1 dma_ack[8] = 0;
   end









always #2.5	clk = ~clk;


always #40.69	bit_clk <= ~bit_clk;







ac97_top	u0(
		.clk_i(		clk		),
		.rst_i(		rst		),
		.wb_data_i(	wb_data_i	),
		.wb_data_o(	wb_data_o	),
		.wb_addr_i(	wb_addr_i	),
		.wb_sel_i(	wb_sel_i	),
		.wb_we_i(	wb_we_i		),
		.wb_cyc_i(	wb_cyc_i	),
		.wb_stb_i(	wb_stb_i	),
		.wb_ack_o(	wb_ack_o	),
		.wb_err_o(	wb_err_o	),
		.int_o(		int		),
		.dma_req_o(	dma_req		),
		.dma_ack_i(	dma_ack		),
		.suspended_o(	suspended	),
		.bit_clk_pad_i(	bit_clk		),
		.sync_pad_o(	sync		),
		.sdata_pad_o(	sdata_out	),
		.sdata_pad_i(	sdata_in	),
		.ac97_reset_pad_o_(	ac97_reset_	)
		);






wb_mast	m0(	.clk(		clk		),
		.rst(		rst		),
		.adr(		wb_addr_i	),
		.din(		wb_data_o	),
		.dout(		wb_data_i	),
		.cyc(		wb_cyc_i	),
		.stb(		wb_stb_i	),
		.sel(		wb_sel_i	),
		.we(		wb_we_i		),
		.ack(		wb_ack_o	),
		.err(		wb_err_o	),
		.rty(				)
		);







ac97_codec_top	u1(
		.clk(		bit_clk		),
		.rst(		rst		),
		.sync(		sync		),
		.sdata_out(	sdata_in	),
		.sdata_in(	sdata_out	)
		);









`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\tests.v"











































































task show_errors;

begin

$display("\n");
$display("     +--------------------+");
$display("     |  Total ERRORS: %0d   |", error_cnt);
$display("     +--------------------+");

end
endtask


task basic1;

reg	[31:0]	data;
reg	[31:0]	data1;
reg	[31:0]	data2;
integer		size, frames, m;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** Basic AC97 I/O Test & Reg Wr ...              ***");
$display("*****************************************************\n");


	wb_busy = 1;
	m0.wb_wr1( 8'h14,4'hf, 32'h0000_0003);
	m0.wb_wr1( 8'h04,4'hf, 32'h7373_7373);
	m0.wb_wr1( 8'h08,4'hf, 32'h0000_7373);
	m0.wb_wr1( 8'h0c,4'hf, 32'h0073_7373);

	wb_busy = 0;
	oc0_dma_en = 1;
	oc1_dma_en = 1;
	oc2_dma_en = 1;
	oc3_dma_en = 1;
	oc4_dma_en = 1;
	oc5_dma_en = 1;
	ic0_dma_en = 1;
	ic1_dma_en = 1;
	ic2_dma_en = 1;

	for(n=0;n<256;n=n+1)
	   begin
		oc0_mem[n] = $random;
		oc1_mem[n] = $random;
		oc2_mem[n] = $random;
		oc3_mem[n] = $random;
		oc4_mem[n] = $random;
		oc5_mem[n] = $random;
		ic0_mem[n] = $random;
		ic1_mem[n] = $random;
		ic2_mem[n] = $random;
	   end

	u1.init(0);
	frames = 139;

fork
	u1.tx1(	frames,					
		0,					
		10'b1111_1111_11,			
		10'b1111_1111_11,			
		20'b00_00_00_00_00_00_00_00_00_00,	
		20'b00_00_00_00_00_00_00_00_00_00	
		);

	begin	
		repeat(2)	@(posedge sync);

		for(n=0;n<75;n=n+1)
		   begin
			@(negedge sync);
			
			repeat(130)	@(posedge bit_clk);

			repeat(n)	@(posedge bit_clk);

			while(wb_busy)	@(posedge clk);
			wb_busy = 1;
			m0.wb_wr1( 8'h10,4'hf, {9'h0, n[6:0], 16'h1234 + n[7:0]} );
			wb_busy = 0;

			while(!int)	@(posedge clk);
		   end
	end
join

repeat(300)	@(posedge bit_clk);

	for(n=0;n<75;n=n+1)
	   begin
			data2 = {9'h0, n[6:0], 16'h1234 + n[7:0]};
			tmp = u1.rs2_mem[n];
			data1[15:0] = tmp[19:4];

			tmp = u1.rs1_mem[n];
			data1[31:16] = {9'h0, tmp[18:12]};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Register Write Data %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end

	   end

	size = frames - 12;

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs3_mem[n];
		data = oc0_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH0 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs4_mem[n];
		data = oc1_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH1 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs6_mem[n];
		data = oc2_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH2 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs7_mem[n];
		data = oc3_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH3 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs8_mem[n];
		data = oc4_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH4 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs9_mem[n];
		data = oc5_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH5 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is3_mem[n];
		data = ic0_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH0 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is4_mem[n];
		data = ic1_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH1 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is6_mem[n];
		data = ic2_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH2 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

repeat(10)	@(posedge clk);

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end
endtask



task basic2;

reg	[31:0]	data;
reg	[31:0]	data1;
reg	[31:0]	data2;
integer		size, frames, m;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** Basic AC97 I/O Test & Reg Rd ...              ***");
$display("*****************************************************\n");

	wb_busy = 1;
	m0.wb_wr1( 8'h14,4'hf, 32'h0000_0003);
	m0.wb_wr1( 8'h04,4'hf, 32'h7373_7373);
	m0.wb_wr1( 8'h08,4'hf, 32'h0000_7373);
	m0.wb_wr1( 8'h0c,4'hf, 32'h0073_7373);

	wb_busy = 0;
	oc0_dma_en = 1;
	oc1_dma_en = 1;
	oc2_dma_en = 1;
	oc3_dma_en = 1;
	oc4_dma_en = 1;
	oc5_dma_en = 1;
	ic0_dma_en = 1;
	ic1_dma_en = 1;
	ic2_dma_en = 1;

	for(n=0;n<256;n=n+1)
	   begin
		oc0_mem[n] = $random;
		oc1_mem[n] = $random;
		oc2_mem[n] = $random;
		oc3_mem[n] = $random;
		oc4_mem[n] = $random;
		oc5_mem[n] = $random;
		ic0_mem[n] = $random;
		ic1_mem[n] = $random;
		ic2_mem[n] = $random;
	   end

	u1.init(0);
	frames = 139;

fork
	u1.tx1(	frames,					
		0,					
		10'b1111_1111_11,			
		10'b1111_1111_11,			
		20'b00_00_00_00_00_00_00_00_00_00,	
		20'b00_00_00_00_00_00_00_00_00_00	
		);

	begin	
		repeat(2)	@(posedge sync);

		for(n=0;n<75;n=n+1)
		   begin
			@(negedge sync);
			
			repeat(130)	@(posedge bit_clk);

			repeat(n)	@(posedge bit_clk);

			while(wb_busy)	@(posedge clk);
			wb_busy = 1;
			m0.wb_wr1( 8'h10,4'hf, {1'b1, 8'h0, n[6:0], 16'h1234 + n[7:0]} );
			wb_busy = 0;

			while(!int)	@(posedge clk);

			while(wb_busy)	@(posedge clk);
			wb_busy = 1;
			m0.wb_rd1( 8'h10,4'hf, reg_mem[n] );
			wb_busy = 0;

		   end
	end
join

repeat(300)	@(posedge bit_clk);

	for(n=0;n<75;n=n+1)
	   begin

			tmp = u1.is2_mem[n];
			data2 = {16'h0, tmp[19:4]};
			tmp = reg_mem[n];
			data1 = {16'h0, tmp[15:0]};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Register Read Data %0d Mismatch Expected: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end

	   end

	size = frames - 4;

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs3_mem[n];
		data = oc0_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH0 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs4_mem[n];
		data = oc1_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH1 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs6_mem[n];
		data = oc2_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH2 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs7_mem[n];
		data = oc3_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH3 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs8_mem[n];
		data = oc4_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH4 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs9_mem[n];
		data = oc5_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH5 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is3_mem[n];
		data = ic0_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH0 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is4_mem[n];
		data = ic1_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH1 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is6_mem[n];
		data = ic2_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH2 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end
endtask



task vsr1;

reg	[31:0]	data;
reg	[31:0]	data1;
reg	[31:0]	data2;
integer		size, frames, m;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** VSR AC97 I/O Test ...                       ***");
$display("*****************************************************\n");

	wb_busy = 1;
	m0.wb_wr1( 8'h14,4'hf, 32'h0492_4924);

	m0.wb_wr1( 8'h04,4'hf, 32'h7373_7373);
	m0.wb_wr1( 8'h08,4'hf, 32'h0000_7373);
	m0.wb_wr1( 8'h0c,4'hf, 32'h0073_7373);

	wb_busy = 0;

	oc0_dma_en = 1;
	oc1_dma_en = 1;
	oc2_dma_en = 1;
	oc3_dma_en = 1;
	oc4_dma_en = 1;
	oc5_dma_en = 1;
	ic0_dma_en = 1;
	ic1_dma_en = 1;
	ic2_dma_en = 1;

	for(n=0;n<256;n=n+1)
	   begin
		oc0_mem[n] = $random;
		oc1_mem[n] = $random;
		oc2_mem[n] = $random;
		oc3_mem[n] = $random;
		oc4_mem[n] = $random;
		oc5_mem[n] = $random;
		ic0_mem[n] = $random;
		ic1_mem[n] = $random;
		ic2_mem[n] = $random;
	   end

	u1.init(0);

	frames = 132;

	u1.tx1(	frames,					
		0,					
		10'b1101_1110_00,			
		10'b1101_0000_00,			
		20'b01_01_00_01_01_01_01_00_00_00,	
		20'b01_01_00_01_00_00_00_00_00_00	
		);

	size = (frames - 4)/2;

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs3_mem[n];
		data = oc0_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH0 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs4_mem[n];
		data = oc1_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH1 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs6_mem[n];
		data = oc2_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH2 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs7_mem[n];
		data = oc3_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH3 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs8_mem[n];
		data = oc4_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH4 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs9_mem[n];
		data = oc5_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH5 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is3_mem[n];
		data = ic0_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH0 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is4_mem[n];
		data = ic1_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH1 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is6_mem[n];
		data = ic2_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH2 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

repeat(10)	@(posedge clk);

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end
endtask



task vsr_int;

reg	[31:0]	data;
reg	[31:0]	data1;
reg	[31:0]	data2;
integer		size, frames, m, th, smpl;

begin
$display("\n\n");
$display("*****************************************************");
$display("*** VSR AC97 I/O Test (INT ctrl) ...              ***");
$display("*****************************************************\n");

for(smpl=0;smpl<4;smpl=smpl+1)
begin
$display("Sampling selection: %0d",smpl);
for(th=0;th<4;th=th+1)
   begin
	do_rst;

	while(wb_busy)	@(posedge clk);

	wb_busy = 1;

	m0.wb_wr1( 8'h14,4'hf, 32'hffff_fffc);

	case(th)
	0:
	begin
	$display("Interrupt threshold: 100%");
	oc0_th = 4;	
	oc1_th = 4;
	oc2_th = 4;
	oc3_th = 4;
	oc4_th = 4;
	oc5_th = 4;
	ic0_th = 4;
	ic1_th = 4;
	ic2_th = 4;

	m0.wb_wr1( 8'h04,4'hf, 32'h3333_3333);
	m0.wb_wr1( 8'h08,4'hf, 32'h0000_3333);
	m0.wb_wr1( 8'h0c,4'hf, 32'h0033_3333);
	end

	1:
	begin
	$display("Interrupt threshold: 75%");
	oc0_th = 3;	
	oc1_th = 3;
	oc2_th = 3;
	oc3_th = 3;
	oc4_th = 3;
	oc5_th = 3;
	ic0_th = 3;
	ic1_th = 3;
	ic2_th = 3;

	m0.wb_wr1( 8'h04,4'hf, 32'h2323_2323);
	m0.wb_wr1( 8'h08,4'hf, 32'h0000_2323);
	m0.wb_wr1( 8'h0c,4'hf, 32'h0023_2323);
	end

	2:
	begin
	$display("Interrupt threshold: 50%");
	oc0_th = 2;	
	oc1_th = 2;
	oc2_th = 2;
	oc3_th = 2;
	oc4_th = 2;
	oc5_th = 2;
	ic0_th = 2;
	ic1_th = 2;
	ic2_th = 2;

	m0.wb_wr1( 8'h04,4'hf, 32'h1313_1313);
	m0.wb_wr1( 8'h08,4'hf, 32'h0000_1313);
	m0.wb_wr1( 8'h0c,4'hf, 32'h0013_1313);
	end

	3:
	begin
	$display("Interrupt threshold: 25%");
	oc0_th = 1;	
	oc1_th = 1;
	oc2_th = 1;
	oc3_th = 1;
	oc4_th = 1;
	oc5_th = 1;
	ic0_th = 1;
	ic1_th = 1;
	ic2_th = 1;

	m0.wb_wr1( 8'h04,4'hf, 32'h0303_0303);
	m0.wb_wr1( 8'h08,4'hf, 32'h0000_0303);
	m0.wb_wr1( 8'h0c,4'hf, 32'h0003_0303);
	end
	endcase


































	wb_busy = 0;

	oc0_dma_en = 0;
	oc1_dma_en = 0;
	oc2_dma_en = 0;
	oc3_dma_en = 0;
	oc4_dma_en = 0;
	oc5_dma_en = 0;
	ic0_dma_en = 0;
	ic1_dma_en = 0;
	ic2_dma_en = 0;
	int_chk_en = 0;
	int_ctrl_en = 1;

	for(n=0;n<256;n=n+1)
	   begin
		oc0_mem[n] = $random;
		oc1_mem[n] = $random;
		oc2_mem[n] = $random;
		oc3_mem[n] = $random;
		oc4_mem[n] = $random;
		oc5_mem[n] = $random;
		ic0_mem[n] = $random;
		ic1_mem[n] = $random;
		ic2_mem[n] = $random;
	   end

	u1.init(0);
	frames = 132;
	frames = 132 + 132 + 132;


	case(smpl)
	   0:	
		u1.tx1(	frames,			
			0,			
			10'b1101_1110_00,	
			10'b1101_0000_00,	
			20'b00_00_00_00_00_00_00_00_00_00,  
			20'b00_00_00_00_00_00_00_00_00_00  
			);
	   1:	
		u1.tx1(	frames,			
			0,			
			10'b1101_1110_00,	
			10'b1101_0000_00,	
			20'b11_11_00_11_11_11_11_00_00_00,  
			20'b11_11_00_11_00_00_00_00_00_00  
			);
	   2:	
		u1.tx1(	frames,			
			0,			
			10'b1101_1110_00,	
			10'b1101_0000_00,	
			20'b00_01_00_10_11_01_10_00_00_00,  
			20'b11_10_00_01_00_00_00_00_00_00  
			);
	   3:	
		u1.tx1(	frames,			
			0,			
			10'b1101_1110_00,	
			10'b1101_0000_00,	
			20'b00_00_00_01_01_10_10_00_00_00,  
			20'b00_00_00_10_00_00_00_00_00_00  
			);
	endcase


	size = (frames - 4)/2;
	size = (frames - 4)/3;
	size = size - 36;

	repeat(100)	@(posedge clk);

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs3_mem[n];
		data = oc0_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH0 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end


	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs4_mem[n];
		data = oc1_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH1 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs6_mem[n];
		data = oc2_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH2 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs7_mem[n];
		data = oc3_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH3 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs8_mem[n];
		data = oc4_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH4 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.rs9_mem[n];
		data = oc5_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: Out. CH5 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is3_mem[n];
		data = ic0_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH0 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is4_mem[n];
		data = ic1_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH1 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

	for(n=0;n<size;n=n+1)
	   begin
		data1 = u1.is6_mem[n];
		data = ic2_mem[n[8:1]];

		if(~n[0])	data2 = {12'h0, data[15:0], 4'h0};
		else		data2 = {12'h0, data[31:16], 4'h0};

		if(	(data1 !== data2) |
			(^data1 === 1'hx) |
			(^data2 === 1'hx)
			)
		   begin
			$display("ERROR: In. CH2 Sample %0d Mismatch Sent: %h Got: %h",
			n, data2, data1);
			error_cnt = error_cnt + 1;
		   end
	   end

repeat(10)	@(posedge clk);
end
end

$display("Processed %0d samples per channel for each test",size);

show_errors;
$display("*****************************************************");
$display("*** Test DONE ...                                 ***");
$display("*****************************************************\n\n");

end
endtask




`line 1025 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\test_bench_top.v"


endmodule




`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\wb_mast_model.v"


























































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\wb_model_defines.v"


























































`timescale 1ns / 10ps

`line 59 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\bench\verilog\wb_mast_model.v"


module wb_mast(clk, rst, adr, din, dout, cyc, stb, sel, we, ack, err, rty);

input		clk, rst;
output	[31:0]	adr;
input	[31:0]	din;
output	[31:0]	dout;
output		cyc, stb;
output	[3:0]	sel;
output		we;
input		ack, err, rty;






parameter mem_size = 4096;

reg	[31:0]	adr;
reg	[31:0]	dout;
reg		cyc, stb;
reg	[3:0]	sel;
reg		we;

reg	[31:0]	rd_mem[mem_size:0];
reg	[31:0]	wr_mem[mem_size:0];
integer		rd_cnt;
integer		wr_cnt;






initial
   begin
	
	
	adr = 32'hffff_ffff;
	dout = 32'hxxxx_xxxx;
	cyc = 0;
	stb = 0;
	sel = 4'hx;
	we = 1'hx;
	rd_cnt = 0;
	wr_cnt = 0;
	#1;
	$display("\nINFO: WISHBONE MASTER MODEL INSTANTIATED (%m)\n");
   end



task mem_fill;

integer n;
begin
rd_cnt = 0;
wr_cnt = 0;
for(n=0;n<mem_size;n=n+1)
   begin
	rd_mem[n] = $random;
	wr_mem[n] = $random;
   end
end
endtask






task wb_wr1;
input	[31:0]	a;
input	[3:0]	s;
input	[31:0]	d;

begin

@(posedge clk);
#1;
adr = a;
dout = d;
cyc = 1;
stb = 1;
we=1;
sel = s;

@(posedge clk);
while(~ack & ~err)	@(posedge clk);
#1;
cyc=0;
stb=0;
adr = 32'hxxxx_xxxx;


dout = 32'hxxxx_xxxx;
we = 1'hx;
sel = 4'hx;

end
endtask






task wb_wr4;
input	[31:0]	a;
input	[3:0]	s;
input		delay;
input	[31:0]	d1;
input	[31:0]	d2;
input	[31:0]	d3;
input	[31:0]	d4;

integer		delay;

begin

@(posedge clk);
#1;
cyc = 1;
sel = s;

repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
adr = a;
dout = d1;
stb = 1;
we=1;
while(~ack & ~err)	@(posedge clk);
#2;
stb=0;
we=1'bx;
dout = 32'hxxxx_xxxx;


repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
stb=1;

dout = d2;
we=1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
#2;
stb=0;
we=1'bx;
dout = 32'hxxxx_xxxx;

repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
stb=1;

dout = d3;
we=1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
#2;
stb=0;
we=1'bx;
dout = 32'hxxxx_xxxx;

repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
stb=1;

dout = d4;
we=1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
#1;
stb=0;
cyc=0;

adr = 32'hxxxx_xxxx;


dout = 32'hxxxx_xxxx;
we = 1'hx;
sel = 4'hx;

end
endtask


task wb_wr_mult;
input	[31:0]	a;
input	[3:0]	s;
input		delay;
input		count;

integer		delay;
integer		count;
integer		n;

begin

@(posedge clk);
#1;
cyc = 1;

for(n=0;n<count;n=n+1)
   begin
	repeat(delay)
	   begin
		@(posedge clk);
		#1;
	   end
	adr = a + (n*4);
	dout = wr_mem[n + wr_cnt];
	stb = 1;
	we=1;
	sel = s;
	if(n!=0)	@(posedge clk);
	while(~ack & ~err)	@(posedge clk);
	#2;
	stb=0;
	we=1'bx;
	sel = 4'hx;
	dout = 32'hxxxx_xxxx;
	adr = 32'hxxxx_xxxx;
   end

cyc=0;

adr = 32'hxxxx_xxxx;


wr_cnt = wr_cnt + count;
end
endtask


task wb_rmw;
input	[31:0]	a;
input	[3:0]	s;
input		delay;
input		rcount;
input		wcount;

integer		delay;
integer		rcount;
integer		wcount;
integer		n;

begin

@(posedge clk);
#1;
cyc = 1;
we = 0;
sel = s;
repeat(delay)	@(posedge clk);

for(n=0;n<rcount-1;n=n+1)
   begin
	adr = a + (n*4);
	stb = 1;
	while(~ack & ~err)	@(posedge clk);
	rd_mem[n + rd_cnt] = din;
	
	#2;
	stb=0;
	we = 1'hx;
	sel = 4'hx;
	adr = 32'hxxxx_xxxx;
	repeat(delay)
	   begin
		@(posedge clk);
		#1;
	   end
	we = 0;
	sel = s;
   end

adr = a+(n*4);
stb = 1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
rd_mem[n + rd_cnt] = din;

#1;
stb=0;
we = 1'hx;
sel = 4'hx;
adr = 32'hxxxx_xxxx;

rd_cnt = rd_cnt + rcount;




for(n=0;n<wcount;n=n+1)
   begin
	repeat(delay)
	   begin
		@(posedge clk);
		#1;
	   end
	adr = a + (n*4);
	dout = wr_mem[n + wr_cnt];
	stb = 1;
	we=1;
	sel = s;

		@(posedge clk);
	while(~ack & ~err)	@(posedge clk);
	#2;
	stb=0;
	we=1'bx;
	sel = 4'hx;
	dout = 32'hxxxx_xxxx;
	adr = 32'hxxxx_xxxx;
   end

cyc=0;

adr = 32'hxxxx_xxxx;


wr_cnt = wr_cnt + wcount;
end
endtask








task wb_rd1;
input	[31:0]	a;
input	[3:0]	s;
output	[31:0]	d;

begin

@(posedge clk);
#1;
adr = a;
cyc = 1;
stb = 1;
we  = 0;
sel = s;


while(~ack & ~err)	@(posedge clk);
d = din;
#1;
cyc=0;
stb=0;


adr = 32'hffff_ffff;
dout = 32'hxxxx_xxxx;
we = 1'hx;
sel = 4'hx;

end
endtask








task wb_rd4;
input	[31:0]	a;
input	[3:0]	s;
input		delay;
output	[31:0]	d1;
output	[31:0]	d2;
output	[31:0]	d3;
output	[31:0]	d4;

integer		delay;
begin

@(posedge clk);
#1;
cyc = 1;
we = 0;
sel = s;
repeat(delay)	@(posedge clk);

adr = a;
stb = 1;
while(~ack & ~err)	@(posedge clk);
d1 = din;
#2;
stb=0;
we = 1'hx;
sel = 4'hx;
repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
we = 0;
sel = s;


stb = 1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
d2 = din;
#2;
stb=0;
we = 1'hx;
sel = 4'hx;
repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
we = 0;
sel = s;



stb = 1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
d3 = din;
#2;
stb=0;
we = 1'hx;
sel = 4'hx;
repeat(delay)
   begin
	@(posedge clk);
	#1;
   end
we = 0;
sel = s;


stb = 1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
d4 = din;
#1;
stb=0;
cyc=0;
we = 1'hx;
sel = 4'hx;
adr = 32'hffff_ffff;
end
endtask



task wb_rd_mult;
input	[31:0]	a;
input	[3:0]	s;
input		delay;
input		count;

integer		delay;
integer		count;
integer		n;

begin

@(posedge clk);
#1;
cyc = 1;
we = 0;
sel = s;
repeat(delay)	@(posedge clk);

for(n=0;n<count-1;n=n+1)
   begin
	adr = a + (n*4);
	stb = 1;
	while(~ack & ~err)	@(posedge clk);
	rd_mem[n + rd_cnt] = din;
	#2;
	stb=0;
	we = 1'hx;
	sel = 4'hx;
	adr = 32'hxxxx_xxxx;
	repeat(delay)
	   begin
		@(posedge clk);
		#1;
	   end
	we = 0;
	sel = s;
   end

adr = a+(n*4);
stb = 1;
@(posedge clk);
while(~ack & ~err)	@(posedge clk);
rd_mem[n + rd_cnt] = din;
#1;
stb=0;
cyc=0;
we = 1'hx;
sel = 4'hx;
adr = 32'hffff_ffff;
adr = 32'hxxxx_xxxx;

rd_cnt = rd_cnt + count;
end
endtask

endmodule


`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_wb_if.v"















































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 80 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_wb_if.v"


module ac97_wb_if(clk, rst,

		wb_data_i, wb_data_o, wb_addr_i, wb_sel_i, wb_we_i, wb_cyc_i,
		wb_stb_i, wb_ack_o, wb_err_o, 

		adr, dout, rf_din, i3_din, i4_din, i6_din,
		rf_we, rf_re, o3_we, o4_we, o6_we, o7_we, o8_we, o9_we,
		i3_re, i4_re, i6_re

		);

input		clk,rst;


input	[31:0]	wb_data_i;
output	[31:0]	wb_data_o;
input	[31:0]	wb_addr_i;
input	[3:0]	wb_sel_i;
input		wb_we_i;
input		wb_cyc_i;
input		wb_stb_i;
output		wb_ack_o;
output		wb_err_o;


output	[3:0]	adr;
output	[31:0]	dout;
input	[31:0]	rf_din, i3_din, i4_din, i6_din;
output		rf_we;
output		rf_re;
output		o3_we, o4_we, o6_we, o7_we, o8_we, o9_we;
output		i3_re, i4_re, i6_re;






reg	[31:0]	wb_data_o;
reg	[31:0]	dout;
reg		wb_ack_o;

reg		rf_we;
reg		o3_we, o4_we, o6_we, o7_we, o8_we, o9_we;
reg		i3_re, i4_re, i6_re;

reg		we1, we2;
wire		we;
reg		re2, re1;
wire		re;






assign adr = wb_addr_i[5:2];

assign wb_err_o = 1'b0;

always @(posedge clk)
	dout <= #1 wb_data_i;

always @(posedge clk)
	case(wb_addr_i[6:2])	
	   5'he: wb_data_o <= #1 i3_din;
	   5'hf: wb_data_o <= #1 i4_din;
	   5'h10: wb_data_o <= #1 i6_din;
	   default: wb_data_o <= #1 rf_din;
	endcase

always @(posedge clk)
	re1 <= #1 !re2 & wb_cyc_i & wb_stb_i & !wb_we_i &  ( wb_addr_i [ 31 : 29 ] == 3'h0 );

always @(posedge clk)
	re2 <= #1 re & wb_cyc_i & wb_stb_i & !wb_we_i ;

assign re = re1 & !re2 & wb_cyc_i & wb_stb_i & !wb_we_i;

assign rf_re = re & (wb_addr_i[6:2] < 5'h8);

always @(posedge clk)
	we1 <= #1 !we & wb_cyc_i & wb_stb_i & wb_we_i &  ( wb_addr_i [ 31 : 29 ] == 3'h0 );

always @(posedge clk)
	we2 <= #1 we1 & wb_cyc_i & wb_stb_i & wb_we_i;

assign we = we1 & !we2 & wb_cyc_i & wb_stb_i & wb_we_i;

always @(posedge clk)
	wb_ack_o <= #1 (re | we) & wb_cyc_i & wb_stb_i & ~wb_ack_o;

always @(posedge clk)
	rf_we <= #1 we & (wb_addr_i[6:2] < 5'h8);

always @(posedge clk)
	o3_we <= #1 we & (wb_addr_i[6:2] == 5'h8);

always @(posedge clk)
	o4_we <= #1 we & (wb_addr_i[6:2] == 5'h9);

always @(posedge clk)
	o6_we <= #1 we & (wb_addr_i[6:2] == 5'ha);

always @(posedge clk)
	o7_we <= #1 we & (wb_addr_i[6:2] == 5'hb);

always @(posedge clk)
	o8_we <= #1 we & (wb_addr_i[6:2] == 5'hc);

always @(posedge clk)
	o9_we <= #1 we & (wb_addr_i[6:2] == 5'hd);

always @(posedge clk)
	i3_re <= #1 re & (wb_addr_i[6:2] == 5'he);

always @(posedge clk)
	i4_re <= #1 re & (wb_addr_i[6:2] == 5'hf);

always @(posedge clk)
	i6_re <= #1 re & (wb_addr_i[6:2] == 5'h10);

endmodule


`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_cra.v"









































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 74 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_cra.v"


module ac97_cra(clk, rst,

		crac_we, crac_din, crac_out,
		crac_wr_done, crac_rd_done,

		valid, out_slt1, out_slt2,
		in_slt2,

		crac_valid, crac_wr
		);

input		clk, rst;
input		crac_we;
output	[15:0]	crac_din;
input	[31:0]	crac_out;
output		crac_wr_done, crac_rd_done;

input		valid;
output	[19:0]	out_slt1;
output	[19:0]	out_slt2;
input	[19:0]	in_slt2;

output		crac_valid;
output		crac_wr;







reg		crac_wr;
reg		crac_rd;
reg		crac_rd_done;
reg	[15:0]	crac_din;
reg		crac_we_r;
reg		valid_r;
wire		valid_ne;
wire		valid_pe;
reg		rdd1, rdd2, rdd3;







assign out_slt1[19]    = crac_out[31];
assign out_slt1[18:12] = crac_out[22:16];
assign out_slt1[11:0]  = 12'h0;


assign out_slt2[19:4] = crac_out[15:0];
assign out_slt2[3:0] = 4'h0;


always @(posedge clk or negedge rst)
   begin
	if(!rst)		crac_din <= #1 16'h0;
	else
	if(crac_rd_done)	crac_din <= #1 in_slt2[19:4];
   end






assign crac_valid = crac_wr | crac_rd;

always @(posedge clk)
	crac_we_r <= #1 crac_we;

always @(posedge clk or negedge rst)
	if(!rst)			crac_wr <= #1 1'b0;
	else
	if(crac_we_r & !crac_out[31])	crac_wr <= #1 1'b1;
	else
	if(valid_ne)			crac_wr <= #1 1'b0;

assign crac_wr_done = crac_wr & valid_ne;

always @(posedge clk or negedge rst)
	if(!rst)			crac_rd <= #1 1'b0;
	else
	if(crac_we_r & crac_out[31])	crac_rd <= #1 1'b1;
	else
	if(rdd1 & valid_pe)		crac_rd <= #1 1'b0;

always @(posedge clk or negedge rst)
	if(!rst)			rdd1 <= #1 1'b0;
	else
	if(crac_rd & valid_ne)		rdd1 <= #1 1'b1;
	else
	if(!crac_rd)			rdd1 <= #1 1'b0;

always @(posedge clk or negedge rst)
	if(!rst)					rdd2 <= #1 1'b0;
	else
	if( (crac_rd & valid_ne) | (!rdd3 & rdd2) )	rdd2 <= #1 1'b1;
	else
	if(crac_rd_done)				rdd2 <= #1 1'b0;

always @(posedge clk or negedge rst)
	if(!rst)			rdd3 <= #1 1'b0;
	else
	if(rdd2 & valid_pe)		rdd3 <= #1 1'b1;
	else
	if(crac_rd_done)		rdd3 <= #1 1'b0;

always @(posedge clk)
	crac_rd_done <= #1 rdd3 & valid_pe;

always @(posedge clk)
	valid_r <= #1 valid;

assign valid_ne = !valid & valid_r;

assign valid_pe = valid & !valid_r;

endmodule


`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps




























































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_dma_if.v"















































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 80 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_dma_if.v"


module ac97_dma_if(clk, rst,
		o3_status, o4_status, o6_status, o7_status, o8_status, o9_status,
		o3_empty, o4_empty, o6_empty, o7_empty, o8_empty, o9_empty,
		i3_status, i4_status, i6_status,
		i3_full, i4_full, i6_full,

		oc0_cfg, oc1_cfg, oc2_cfg, oc3_cfg, oc4_cfg, oc5_cfg,
		ic0_cfg, ic1_cfg, ic2_cfg,

		dma_req, dma_ack);

input		clk, rst;
input	[1:0]	o3_status, o4_status, o6_status, o7_status, o8_status, o9_status;
input		o3_empty, o4_empty, o6_empty, o7_empty, o8_empty, o9_empty;
input	[1:0]	i3_status, i4_status, i6_status;
input		i3_full, i4_full, i6_full;
input	[7:0]	oc0_cfg;
input	[7:0]	oc1_cfg;
input	[7:0]	oc2_cfg;
input	[7:0]	oc3_cfg;
input	[7:0]	oc4_cfg;
input	[7:0]	oc5_cfg;
input	[7:0]	ic0_cfg;
input	[7:0]	ic1_cfg;
input	[7:0]	ic2_cfg;
output	[8:0]	dma_req;
input	[8:0]	dma_ack;






ac97_dma_req u0(.clk(		clk		),
		.rst(		rst		),
		.cfg(		oc0_cfg		),
		.status(	o3_status	),
		.full_empty(	o3_empty	),
		.dma_req(	dma_req[0]	),
		.dma_ack(	dma_ack[0]	)
		);

ac97_dma_req u1(.clk(		clk		),
		.rst(		rst		),
		.cfg(		oc1_cfg		),
		.status(	o4_status	),
		.full_empty(	o4_empty	),
		.dma_req(	dma_req[1]	),
		.dma_ack(	dma_ack[1]	)
		);


ac97_dma_req u2(.clk(		clk		),
		.rst(		rst		),
		.cfg(		oc2_cfg		),
		.status(	o6_status	),
		.full_empty(	o6_empty	),
		.dma_req(	dma_req[2]	),
		.dma_ack(	dma_ack[2]	)
		);





ac97_dma_req u3(.clk(		clk		),
		.rst(		rst		),
		.cfg(		oc3_cfg		),
		.status(	o7_status	),
		.full_empty(	o7_empty	),
		.dma_req(	dma_req[3]	),
		.dma_ack(	dma_ack[3]	)
		);

ac97_dma_req u4(.clk(		clk		),
		.rst(		rst		),
		.cfg(		oc4_cfg		),
		.status(	o8_status	),
		.full_empty(	o8_empty	),
		.dma_req(	dma_req[4]	),
		.dma_ack(	dma_ack[4]	)
		);






ac97_dma_req u5(.clk(		clk		),
		.rst(		rst		),
		.cfg(		oc5_cfg		),
		.status(	o9_status	),
		.full_empty(	o9_empty	),
		.dma_req(	dma_req[5]	),
		.dma_ack(	dma_ack[5]	)
		);





ac97_dma_req u6(.clk(		clk		),
		.rst(		rst		),
		.cfg(		ic0_cfg		),
		.status(	i3_status	),
		.full_empty(	i3_full		),
		.dma_req(	dma_req[6]	),
		.dma_ack(	dma_ack[6]	)
		);

ac97_dma_req u7(.clk(		clk		),
		.rst(		rst		),
		.cfg(		ic1_cfg		),
		.status(	i4_status	),
		.full_empty(	i4_full		),
		.dma_req(	dma_req[7]	),
		.dma_ack(	dma_ack[7]	)
		);






ac97_dma_req u8(.clk(		clk		),
		.rst(		rst		),
		.cfg(		ic2_cfg		),
		.status(	i6_status	),
		.full_empty(	i6_full		),
		.dma_req(	dma_req[8]	),
		.dma_ack(	dma_ack[8]	)
		);




endmodule




`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_dma_req.v"








































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 73 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_dma_req.v"


module ac97_dma_req(clk, rst, cfg, status, full_empty, dma_req, dma_ack);
input		clk, rst;
input	[7:0]	cfg;
input	[1:0]	status;
input		full_empty;
output		dma_req;
input		dma_ack;





reg	dma_req_d;
reg	dma_req_r1;
reg	dma_req;






always @(cfg or status or full_empty)
	case(cfg[5:4])	
			
			
	   2'h2: dma_req_d = cfg[0] & cfg[6] & (full_empty | (status == 2'h0));
			
	   2'h1: dma_req_d = cfg[0] & cfg[6] & (full_empty | (status[1] == 1'h0));
			
	   2'h0: dma_req_d = cfg[0] & cfg[6] & (full_empty | (status < 2'h3));
	   2'h3: dma_req_d = cfg[0] & cfg[6] & full_empty;
	endcase

always @(posedge clk)
	dma_req_r1 <= #1 dma_req_d & !dma_ack;

always @(posedge clk or negedge rst)
	if(!rst)				dma_req <= #1 1'b0;
	else
	if(dma_req_r1 & dma_req_d & !dma_ack) 	dma_req <= #1 1'b1;
	else
	if(dma_ack) 				dma_req <= #1 1'b0;

endmodule



`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_fifo_ctrl.v"








































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 73 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_fifo_ctrl.v"


module ac97_fifo_ctrl(	clk, 
			valid, ch_en, srs, full_empty, req, crdy,
			en_out, en_out_l
			);
input		clk;
input		valid;
input		ch_en;		
input		srs;		
input		full_empty;	
input		req;		
input		crdy;		
output		en_out;		
output		en_out_l;	






reg	en_out_l, en_out_l2;
reg	full_empty_r;






always @(posedge clk)
	if(!valid)	full_empty_r <= #1 full_empty;

always @(posedge clk)
	if(valid & ch_en & !full_empty_r & crdy & (!srs | (srs & req) ) )
		en_out_l <= #1 1'b1;
	else
	if(!valid & !(ch_en & !full_empty_r & crdy & (!srs | (srs & req) )) )
		en_out_l <= #1 1'b0;

always @(posedge clk)
	en_out_l2 <= #1 en_out_l & valid;

assign en_out = en_out_l & !en_out_l2 & valid;

endmodule


`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_in_fifo.v"















































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 80 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_in_fifo.v"






module ac97_in_fifo(clk, rst, en, mode, din, we, dout, re, status, full, empty);

input		clk, rst;
input		en;
input	[1:0]	mode;
input	[19:0]	din;
input		we;
output	[31:0]	dout;
input		re;
output	[1:0]	status;
output		full;
output		empty;







reg	[31:0]	mem[0:3];
reg	[31:0]	dout;

reg	[3:0]	wp;
reg	[2:0]	rp;

wire	[3:0]	wp_p1;

reg	[1:0]	status;
reg	[15:0]	din_tmp1;
reg	[31:0]	din_tmp;
wire		m16b;
reg		full, empty;






assign m16b = (mode == 2'h0);	

always @(posedge clk)
	if(!en)		wp <= #1 4'h0;
	else
	if(we)		wp <= #1 wp_p1;

assign wp_p1 = m16b ? (wp + 4'h1) : (wp + 4'h2);

always @(posedge clk)
	if(!en)		rp <= #1 3'h0;
	else
	if(re)		rp <= #1 rp + 3'h1;

always @(posedge clk)
	status <= #1 ((rp[1:0] - wp[2:1]) - 2'h1);

always @(posedge clk)
	empty <= #1 (wp[3:1] == rp[2:0]) & (m16b ? !wp[0] : 1'b0);

always @(posedge clk)
	full  <= #1 (wp[2:1] == rp[1:0]) & (wp[3] != rp[2]);


always @(posedge clk)
	dout <= #1 mem[ rp[1:0] ];


always @(posedge clk)
	if(we & !wp[0])	din_tmp1 <= #1 din[19:4];

always @(mode or din_tmp1 or din)
	case(mode)	
	   2'h0: din_tmp = {din[19:4], din_tmp1};	
	   2'h1: din_tmp = {14'h0, din[19:2]};		
	   2'h2: din_tmp = {11'h0, din[19:0]};		
	endcase

always @(posedge clk)
	if(we & (!m16b | (m16b & wp[0]) ) )	mem[ wp[2:1] ] <= #1 din_tmp;

endmodule



















































































































































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_int.v"








































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 73 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_int.v"


module ac97_int(clk, rst,

		
		int_set,

		
		cfg, status, full_empty, full, empty, re, we
		);

input		clk, rst;
output	[2:0]	int_set;

input	[7:0]	cfg;
input	[1:0]	status;
input		full_empty, full, empty, re, we;






reg	[2:0]	int_set;






always @(posedge clk or negedge rst)
	if(!rst)	int_set[0] <= #1 1'b0;
	else
	case(cfg[5:4])	
			
	   2'h2: int_set[0] <= #1 cfg[0] & (full_empty | (status == 2'h0));
			
	   2'h1: int_set[0] <= #1 cfg[0] & (full_empty | (status[1] == 1'h0));
			
	   2'h0: int_set[0] <= #1 cfg[0] & (full_empty | (status < 2'h3));	
	   2'h3: int_set[0] <= #1 cfg[0] & full_empty;
	endcase

always @(posedge clk or negedge rst)
	if(!rst)	int_set[1] <= #1 1'b0;
	else
	if(empty & re)	int_set[1] <= #1 1'b1;

always @(posedge clk or negedge rst)
	if(!rst)	int_set[2] <= #1 1'b0;
	else
	if(full & we)	int_set[2] <= #1 1'b1;

endmodule


`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_out_fifo.v"







































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 72 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_out_fifo.v"






module ac97_out_fifo(clk, rst, en, mode, din, we, dout, re, status, full, empty);

input		clk, rst;
input		en;
input	[1:0]	mode;
input	[31:0]	din;
input		we;
output	[19:0]	dout;
input		re;
output	[1:0]	status;
output		full;
output		empty;







reg	[31:0]	mem[0:3];

reg	[2:0]	wp;
reg	[3:0]	rp;

wire	[2:0]	wp_p1;

reg	[1:0]	status;
reg	[19:0]	dout;
wire	[31:0]	dout_tmp;
wire	[15:0]	dout_tmp1;
wire		m16b;
reg		empty;






assign m16b = (mode == 2'h0);	

always @(posedge clk)
	if(!en)		wp <= #1 3'h0;
	else
	if(we)		wp <= #1 wp_p1;

assign wp_p1 = wp + 3'h1;

always @(posedge clk)
	if(!en)		rp <= #1 4'h0;
	else
	if(re & m16b)	rp <= #1 rp + 4'h1;
	else
	if(re & !m16b)	rp <= #1 rp + 4'h2;

always @(posedge clk)
	status <= #1 (wp[1:0] - rp[2:1]) - 2'h1;

wire	[3:0]	rp_p1 = rp[3:0] + 4'h1;

always @(posedge clk)
	empty <= #1 (rp_p1[3:1] == wp[2:0]) & (m16b ? rp_p1[0] : 1'b1);

assign full  = (wp[1:0] == rp[2:1]) & (wp[2] != rp[3]);


assign dout_tmp = mem[ rp[2:1] ];


assign dout_tmp1 = rp[0] ? dout_tmp[31:16] : dout_tmp[15:0];

always @(posedge clk)
	if(!en)		dout <= #1 20'h0;
	else
	if(re)
		case(mode)	
		   2'h0: dout <= #1 {dout_tmp1, 4'h0};		
		   2'h1: dout <= #1 {dout_tmp[17:0], 2'h0};	
		   2'h2: dout <= #1 dout_tmp[19:0];		
		endcase

always @(posedge clk)
	if(we)	mem[wp[1:0]] <= #1 din;

endmodule





























































































































































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_prc.v"















































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 80 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_prc.v"


module ac97_prc(clk, rst,

		
		valid, in_valid, out_slt0,
		in_slt0, in_slt1,

		
		crac_valid, crac_wr,

		
		oc0_cfg, oc1_cfg, oc2_cfg, oc3_cfg, oc4_cfg, oc5_cfg,
		ic0_cfg, ic1_cfg, ic2_cfg,

		
		o3_empty, o4_empty, o6_empty, o7_empty, o8_empty,
		o9_empty, i3_full, i4_full, i6_full,

		
		o3_re, o4_re, o6_re, o7_re, o8_re, o9_re,
		i3_we, i4_we, i6_we

	);
input		clk, rst;

input		valid;
input	[2:0]	in_valid;
output	[15:0]	out_slt0;
input	[15:0]	in_slt0;
input	[19:0]	in_slt1;

input		crac_valid;
input		crac_wr;

input	[7:0]	oc0_cfg;
input	[7:0]	oc1_cfg;
input	[7:0]	oc2_cfg;
input	[7:0]	oc3_cfg;
input	[7:0]	oc4_cfg;
input	[7:0]	oc5_cfg;

input	[7:0]	ic0_cfg;
input	[7:0]	ic1_cfg;
input	[7:0]	ic2_cfg;

input		o3_empty;
input		o4_empty;
input		o6_empty;
input		o7_empty;
input		o8_empty;
input		o9_empty;
input		i3_full;
input		i4_full;
input		i6_full;

output		o3_re;
output		o4_re;
output		o6_re;
output		o7_re;
output		o8_re;
output		o9_re;
output		i3_we;
output		i4_we;
output		i6_we;
		





wire		o3_re_l;
wire		o4_re_l;
wire		o6_re_l;
wire		o7_re_l;
wire		o8_re_l;
wire		o9_re_l;

reg		crac_valid_r;
reg		crac_wr_r;






assign out_slt0[15] = |out_slt0[14:6];

assign out_slt0[14] = crac_valid_r;
assign out_slt0[13] = crac_wr_r;

assign out_slt0[12] = o3_re_l;
assign out_slt0[11] = o4_re_l;
assign out_slt0[10] = 1'b0;
assign out_slt0[09] = o6_re_l;
assign out_slt0[08] = o7_re_l;
assign out_slt0[07] = o8_re_l;
assign out_slt0[06] = o9_re_l;
assign out_slt0[5:0] = 6'h0;






always @(posedge clk)
	if(valid)	crac_valid_r <= #1 crac_valid;

always @(posedge clk)
	if(valid)	crac_wr_r <= #1 crac_valid & crac_wr;


ac97_fifo_ctrl u0(
		.clk(		clk 		),
		.valid(		valid		),
		.ch_en(		oc0_cfg[0]	),
		.srs(		oc0_cfg[1]	),
		.full_empty(	o3_empty	),
		.req(		~in_slt1[11]	),
		.crdy(		in_slt0[15]	),
		.en_out(	o3_re		),
		.en_out_l(	o3_re_l		)
		);


ac97_fifo_ctrl u1(
		.clk(		clk 		),
		.valid(		valid		),
		.ch_en(		oc1_cfg[0]	),
		.srs(		oc1_cfg[1]	),
		.full_empty(	o4_empty	),
		.req(		~in_slt1[10]	),
		.crdy(		in_slt0[15]	),
		.en_out(	o4_re		),
		.en_out_l(	o4_re_l		)
		);



ac97_fifo_ctrl u2(
		.clk(		clk 		),
		.valid(		valid		),
		.ch_en(		oc2_cfg[0]	),
		.srs(		oc2_cfg[1]	),
		.full_empty(	o6_empty	),
		.req(		~in_slt1[8]	),
		.crdy(		in_slt0[15]	),
		.en_out(	o6_re		),
		.en_out_l(	o6_re_l		)
		);







ac97_fifo_ctrl u3(
		.clk(		clk 		),
		.valid(		valid		),
		.ch_en(		oc3_cfg[0]	),
		.srs(		oc3_cfg[1]	),
		.full_empty(	o7_empty	),
		.req(		~in_slt1[7]	),
		.crdy(		in_slt0[15]	),
		.en_out(	o7_re		),
		.en_out_l(	o7_re_l		)
		);


ac97_fifo_ctrl u4(
		.clk(		clk 		),
		.valid(		valid		),
		.ch_en(		oc4_cfg[0]	),
		.srs(		oc4_cfg[1]	),
		.full_empty(	o8_empty	),
		.req(		~in_slt1[6]	),
		.crdy(		in_slt0[15]	),
		.en_out(	o8_re		),
		.en_out_l(	o8_re_l		)
		);









ac97_fifo_ctrl u5(
		.clk(		clk 		),
		.valid(		valid		),
		.ch_en(		oc5_cfg[0]	),
		.srs(		oc5_cfg[1]	),
		.full_empty(	o9_empty	),
		.req(		~in_slt1[5]	),
		.crdy(		in_slt0[15]	),
		.en_out(	o9_re		),
		.en_out_l(	o9_re_l		)
		);







ac97_fifo_ctrl u6(
		.clk(		clk 		),
		.valid(		in_valid[0]	),
		.ch_en(		ic0_cfg[0]	),
		.srs(		ic0_cfg[1]	),
		.full_empty(	i3_full		),
		.req(		in_slt0[12]	),
		.crdy(		in_slt0[15]	),
		.en_out(	i3_we		),
		.en_out_l(			)
		);


ac97_fifo_ctrl u7(
		.clk(		clk 		),
		.valid(		in_valid[1]	),
		.ch_en(		ic1_cfg[0]	),
		.srs(		ic1_cfg[1]	),
		.full_empty(	i4_full		),
		.req(		in_slt0[11]	),
		.crdy(		in_slt0[15]	),
		.en_out(	i4_we		),
		.en_out_l(			)
		);







ac97_fifo_ctrl u8(
		.clk(		clk 		),
		.valid(		in_valid[2]	),
		.ch_en(		ic2_cfg[0]	),
		.srs(		ic2_cfg[1]	),
		.full_empty(	i6_full		),
		.req(		in_slt0[9]	),
		.crdy(		in_slt0[15]	),
		.en_out(	i6_we		),
		.en_out_l(			)
		);




endmodule




`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_rf.v"















































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 80 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_rf.v"


module ac97_rf(clk, rst,

		adr, rf_dout, rf_din,
		rf_we, rf_re, int, ac97_rst_force,
		resume_req, suspended,

		crac_we, crac_din, crac_out,
		crac_rd_done, crac_wr_done,

		oc0_cfg, oc1_cfg, oc2_cfg, oc3_cfg, oc4_cfg, oc5_cfg,
		ic0_cfg, ic1_cfg, ic2_cfg,
		oc0_int_set, oc1_int_set, oc2_int_set, oc3_int_set,
		oc4_int_set, oc5_int_set,
		ic0_int_set, ic1_int_set, ic2_int_set

		);

input		clk,rst;

input	[3:0]	adr;
output	[31:0]	rf_dout;
input	[31:0]	rf_din;
input		rf_we;
input		rf_re;
output		int;
output		ac97_rst_force;
output		resume_req;
input		suspended;

output		crac_we;
input	[15:0]	crac_din;
output	[31:0]	crac_out;
input		crac_rd_done, crac_wr_done;

output	[7:0]	oc0_cfg;
output	[7:0]	oc1_cfg;
output	[7:0]	oc2_cfg;
output	[7:0]	oc3_cfg;
output	[7:0]	oc4_cfg;
output	[7:0]	oc5_cfg;

output	[7:0]	ic0_cfg;
output	[7:0]	ic1_cfg;
output	[7:0]	ic2_cfg;

input	[2:0]	oc0_int_set;
input	[2:0]	oc1_int_set;
input	[2:0]	oc2_int_set;
input	[2:0]	oc3_int_set;
input	[2:0]	oc4_int_set;
input	[2:0]	oc5_int_set;
input	[2:0]	ic0_int_set;
input	[2:0]	ic1_int_set;
input	[2:0]	ic2_int_set;






reg	[31:0]	rf_dout;

reg	[31:0]	csr_r;
reg	[31:0]	occ0_r;
reg	[15:0]	occ1_r;
reg	[23:0]	icc_r;
reg	[31:0]	crac_r;
reg	[28:0]	intm_r;
reg	[28:0]	ints_r;
reg		int;
wire	[28:0]	int_all;
wire	[31:0]	csr, occ0, occ1, icc, crac, intm, ints;
reg	[15:0]	crac_dout_r;
reg		ac97_rst_force;
reg		resume_req;


assign csr  = {30'h0, suspended, 1'h0};
assign occ0 = occ0_r;
assign occ1 = {16'h0, occ1_r};
assign icc  = {8'h0,  icc_r};
assign crac = {crac_r[7], 8'h0, crac_r[6:0], crac_din};
assign intm = {3'h0, intm_r};
assign ints = {3'h0, ints_r};

assign crac_out = {crac_r[7], 8'h0, crac_r[6:0], crac_dout_r};






always @(adr or csr or occ0 or occ1 or icc or crac or intm or ints)
	case(adr[2:0])	
	   0: rf_dout = csr;
	   1: rf_dout = occ0;
	   2: rf_dout = occ1;
	   3: rf_dout = icc;
	   4: rf_dout = crac;
	   5: rf_dout = intm;
	   6: rf_dout = ints;
	endcase

always @(posedge clk or negedge rst)
	if(!rst)			csr_r <= #1 1'b0;
	else
	if(rf_we & (adr[2:0]==3'h0))	csr_r <= #1 rf_din;

always @(posedge clk)
	if(rf_we & (adr[2:0]==3'h0))	ac97_rst_force <= #1 rf_din[0];
	else				ac97_rst_force <= #1 1'b0;

always @(posedge clk)
	if(rf_we & (adr[2:0]==3'h0))	resume_req <= #1 rf_din[1];
	else				resume_req <= #1 1'b0;

always @(posedge clk or negedge rst)
	if(!rst)			occ0_r <= #1 1'b0;
	else
	if(rf_we & (adr[2:0]==3'h1))	occ0_r <= #1 rf_din;

always @(posedge clk or negedge rst)
	if(!rst)			occ1_r <= #1 1'b0;
	else
	if(rf_we & (adr[2:0]==3'h2))	occ1_r <= #1 rf_din[23:0];

always @(posedge clk or negedge rst)
	if(!rst)			icc_r <= #1 1'b0;
	else
	if(rf_we & (adr[2:0]==3'h3))	icc_r <= #1 rf_din[23:0];

assign crac_we = rf_we & (adr[2:0]==3'h4);

always @(posedge clk or negedge rst)
	if(!rst)			crac_r <= #1 1'b0;
	else
	if(crac_we) 			crac_r <= #1 {rf_din[31], rf_din[22:16]};

always @(posedge clk)
	if(crac_we)			crac_dout_r <= #1 rf_din[15:0];

always @(posedge clk or negedge rst)
	if(!rst)			intm_r <= #1 1'b0;
	else
	if(rf_we & (adr[2:0]==3'h5))	intm_r <= #1 rf_din[28:0];


always @(posedge clk or negedge rst)
	if(!rst)			ints_r <= #1 1'b0;
	else
	if(rf_re & (adr[2:0]==3'h6))	ints_r <= #1 1'b0;
	else
	   begin
		if(crac_rd_done)	ints_r[0] <= #1 1'b1;
		if(crac_wr_done)	ints_r[1] <= #1 1'b1;
		if(oc0_int_set[0])	ints_r[2] <= #1 1'b1;
		if(oc0_int_set[1])	ints_r[3] <= #1 1'b1;
		if(oc0_int_set[2])	ints_r[4] <= #1 1'b1;
		if(oc1_int_set[0])	ints_r[5] <= #1 1'b1;
		if(oc1_int_set[1])	ints_r[6] <= #1 1'b1;
		if(oc1_int_set[2])	ints_r[7] <= #1 1'b1;

		if(oc2_int_set[0])	ints_r[8] <= #1 1'b1;
		if(oc2_int_set[1])	ints_r[9] <= #1 1'b1;
		if(oc2_int_set[2])	ints_r[10] <= #1 1'b1;



		if(oc3_int_set[0])	ints_r[11] <= #1 1'b1;
		if(oc3_int_set[1])	ints_r[12] <= #1 1'b1;
		if(oc3_int_set[2])	ints_r[13] <= #1 1'b1;
		if(oc4_int_set[0])	ints_r[14] <= #1 1'b1;
		if(oc4_int_set[1])	ints_r[15] <= #1 1'b1;
		if(oc4_int_set[2])	ints_r[16] <= #1 1'b1;



		if(oc5_int_set[0])	ints_r[17] <= #1 1'b1;
		if(oc5_int_set[1])	ints_r[18] <= #1 1'b1;
		if(oc5_int_set[2])	ints_r[19] <= #1 1'b1;



		if(ic0_int_set[0])	ints_r[20] <= #1 1'b1;
		if(ic0_int_set[1])	ints_r[21] <= #1 1'b1;
		if(ic0_int_set[2])	ints_r[22] <= #1 1'b1;
		if(ic1_int_set[0])	ints_r[23] <= #1 1'b1;
		if(ic1_int_set[1])	ints_r[24] <= #1 1'b1;
		if(ic1_int_set[2])	ints_r[25] <= #1 1'b1;



		if(ic2_int_set[0])	ints_r[26] <= #1 1'b1;
		if(ic2_int_set[1])	ints_r[27] <= #1 1'b1;
		if(ic2_int_set[2])	ints_r[28] <= #1 1'b1;

	   end






assign oc0_cfg = occ0[7:0];
assign oc1_cfg = occ0[15:8];
assign oc2_cfg = occ0[23:16];
assign oc3_cfg = occ0[31:24];
assign oc4_cfg = occ1[7:0];
assign oc5_cfg = occ1[15:8];

assign ic0_cfg = icc[7:0];
assign ic1_cfg = icc[15:8];
assign ic2_cfg = icc[23:16];






assign int_all = intm_r & ints_r;

always @(posedge clk)
	int <= #1 |int_all;

endmodule


`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_rst.v"





























































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 62 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_rst.v"


module ac97_rst(clk, rst, rst_force, ps_ce, ac97_rst_);
input		clk, rst;
input		rst_force;
output		ps_ce;
output		ac97_rst_;

reg		ac97_rst_;
reg	[2:0]	cnt;
wire		ce;
wire		to;
reg	[5:0]	ps_cnt;
wire		ps_ce;

always @(posedge clk or negedge rst)
	if(!rst)	ac97_rst_ <= #1 0;
	else
	if(rst_force)	ac97_rst_ <= #1 0;
	else
	if(to)		ac97_rst_ <= #1 1;

assign to = (cnt ==  3'h4);

always @(posedge clk or negedge rst)
	if(!rst)	cnt <= #1 0;
	else
	if(rst_force)	cnt <= #1 0;
	else
	if(ce)		cnt <= #1 cnt + 1;

assign ce = ps_ce & (cnt !=  3'h4);

always @(posedge clk or negedge rst)
	if(!rst)		ps_cnt <= #1 0;
	else
	if(ps_ce | rst_force)	ps_cnt <= #1 0;
	else			ps_cnt <= #1 ps_cnt + 1;

assign ps_ce = (ps_cnt ==  6'h31);

endmodule


`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_sin.v"



































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 68 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_sin.v"


module ac97_sin(clk, rst,

	out_le, slt0, slt1, slt2, slt3, slt4,
	slt6, 

	sdata_in
	);

input		clk, rst;



input	[5:0]	out_le;
output	[15:0]	slt0;
output	[19:0]	slt1;
output	[19:0]	slt2;
output	[19:0]	slt3;
output	[19:0]	slt4;
output	[19:0]	slt6;



input		sdata_in;






reg		sdata_in_r;
reg	[19:0]	sr;

reg	[15:0]	slt0;
reg	[19:0]	slt1;
reg	[19:0]	slt2;
reg	[19:0]	slt3;
reg	[19:0]	slt4;
reg	[19:0]	slt6;






always @(posedge clk)
	if(out_le[0])	slt0 <= #1 sr[15:0];

always @(posedge clk)
	if(out_le[1])	slt1 <= #1 sr;

always @(posedge clk)
	if(out_le[2])	slt2 <= #1 sr;

always @(posedge clk)
	if(out_le[3])	slt3 <= #1 sr;

always @(posedge clk)
	if(out_le[4])	slt4 <= #1 sr;

always @(posedge clk)
	if(out_le[5])	slt6 <= #1 sr;






always @(negedge clk)
	sdata_in_r <= #1 sdata_in;

always @(posedge clk)
	sr <= #1 {sr[18:0], sdata_in_r };

endmodule




`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_soc.v"








































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 73 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_soc.v"


module ac97_soc(clk, wclk, rst,
		ps_ce, resume, suspended,
		sync, out_le, in_valid, ld, valid
		);

input		clk, wclk, rst;
input		ps_ce;
input		resume;
output		suspended;
output		sync;
output	[5:0]	out_le;
output	[2:0]	in_valid;
output		ld;
output		valid;






reg	[7:0]	cnt;
reg		sync_beat;
reg		sync_resume;
reg	[5:0]	out_le;
reg		ld;
reg		valid;
reg	[2:0]	in_valid;
reg		bit_clk_r;
reg		bit_clk_r1;
reg		bit_clk_e;
reg		suspended;
wire		to;
reg	[5:0]	to_cnt;
reg	[3:0]	res_cnt;
wire		resume_done;

assign sync = sync_beat | sync_resume;






always @(posedge clk or negedge rst)
	if(!rst)		cnt <= #1 8'hff;
	else
	if(suspended)		cnt <= #1 8'hff;
	else			cnt <= #1 cnt + 8'h1;

always @(posedge clk)
	ld <= #1 (cnt == 8'h00);

always @(posedge clk)
	sync_beat <= #1 (cnt == 8'h00) | ((cnt > 8'h00) & (cnt < 8'h10));

always @(posedge clk)
	valid <= #1 (cnt > 8'h39);

always @(posedge clk)
	out_le[0] <= #1 (cnt == 8'h11);		

always @(posedge clk)
	out_le[1] <= #1 (cnt == 8'h25);		

always @(posedge clk)
	out_le[2] <= #1 (cnt == 8'h39);		

always @(posedge clk)
	out_le[3] <= #1 (cnt == 8'h4d);		

always @(posedge clk)
	out_le[4] <= #1 (cnt == 8'h61);		

always @(posedge clk)
	out_le[5] <= #1 (cnt == 8'h89);		

always @(posedge clk)
	in_valid[0] <= #1 (cnt > 8'h4d);	

always @(posedge clk)
	in_valid[1] <= #1 (cnt > 8'h61);	

always @(posedge clk)
	in_valid[2] <= #1 (cnt > 8'h89);	






always @(posedge wclk)
	bit_clk_r <= #1 clk;

always @(posedge wclk)
	bit_clk_r1 <= #1 bit_clk_r;

always @(posedge wclk)
	bit_clk_e <= #1 (bit_clk_r & !bit_clk_r1) | (!bit_clk_r & bit_clk_r1);

always @(posedge wclk)
	suspended <= #1 to;

assign to = (to_cnt ==  6'h21);

always @(posedge wclk or negedge rst)
	if(!rst)		to_cnt <= #1 6'h0;
	else
	if(bit_clk_e)		to_cnt <= #1 6'h0;
	else
	if(!to)			to_cnt <= #1 to_cnt + 6'h1;






always @(posedge wclk or negedge rst)
	if(!rst)			sync_resume <= #1 1'b0;
	else
	if(resume_done)			sync_resume <= #1 1'b0;
	else
	if(suspended & resume)		sync_resume <= #1 1'b1;

assign resume_done = (res_cnt ==  3'h5);

always @(posedge wclk)
	if(!sync_resume)	res_cnt <= #1 4'h0;
	else
	if(ps_ce)		res_cnt <= #1 res_cnt + 4'h1;

endmodule


`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_sout.v"



































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 68 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_sout.v"


module ac97_sout(clk, rst,

	so_ld, slt0, slt1, slt2, slt3, slt4,
	slt6, slt7, slt8, slt9,

	sdata_out
	);

input		clk, rst;



input		so_ld;
input	[15:0]	slt0;
input	[19:0]	slt1;
input	[19:0]	slt2;
input	[19:0]	slt3;
input	[19:0]	slt4;
input	[19:0]	slt6;
input	[19:0]	slt7;
input	[19:0]	slt8;
input	[19:0]	slt9;



output		sdata_out;






wire		sdata_out;

reg	[15:0]	slt0_r;
reg	[19:0]	slt1_r;
reg	[19:0]	slt2_r;
reg	[19:0]	slt3_r;
reg	[19:0]	slt4_r;
reg	[19:0]	slt5_r;
reg	[19:0]	slt6_r;
reg	[19:0]	slt7_r;
reg	[19:0]	slt8_r;
reg	[19:0]	slt9_r;
reg	[19:0]	slt10_r;
reg	[19:0]	slt11_r;
reg	[19:0]	slt12_r;











assign	sdata_out = slt0_r[15];

always @(posedge clk)
	if(so_ld)	slt0_r <= #1 slt0;
	else		slt0_r <= #1 {slt0_r[14:0], slt1_r[19]};

always @(posedge clk)
	if(so_ld)	slt1_r <= #1 slt1;
	else		slt1_r <= #1 {slt1_r[18:0], slt2_r[19]};

always @(posedge clk)
	if(so_ld)	slt2_r <= #1 slt2;
	else		slt2_r <= #1 {slt2_r[18:0], slt3_r[19]};

always @(posedge clk)
	if(so_ld)	slt3_r <= #1 slt3;
	else		slt3_r <= #1 {slt3_r[18:0], slt4_r[19]};

always @(posedge clk)
	if(so_ld)	slt4_r <= #1 slt4;
	else		slt4_r <= #1 {slt4_r[18:0], slt5_r[19]};

always @(posedge clk)
	if(so_ld)	slt5_r <= #1 20'h0;
	else		slt5_r <= #1 {slt5_r[18:0], slt6_r[19]};

always @(posedge clk)
	if(so_ld)	slt6_r <= #1 slt6;
	else		slt6_r <= #1 {slt6_r[18:0], slt7_r[19]};

always @(posedge clk)
	if(so_ld)	slt7_r <= #1 slt7;
	else		slt7_r <= #1 {slt7_r[18:0], slt8_r[19]};

always @(posedge clk)
	if(so_ld)	slt8_r <= #1 slt8;
	else		slt8_r <= #1 {slt8_r[18:0], slt9_r[19]};

always @(posedge clk)
	if(so_ld)	slt9_r <= #1 slt9;
	else		slt9_r <= #1 {slt9_r[18:0], slt10_r[19]};

always @(posedge clk)
	if(so_ld)	slt10_r <= #1 20'h0;
	else		slt10_r <= #1 {slt10_r[18:0], slt11_r[19]};

always @(posedge clk)
	if(so_ld)	slt11_r <= #1 20'h0;
	else		slt11_r <= #1 {slt11_r[18:0], slt12_r[19]};

always @(posedge clk)
	if(so_ld)	slt12_r <= #1 20'h0;
	else		slt12_r <= #1 {slt12_r[18:0], 1'b0 };

endmodule



`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_top.v"














































































`line 1 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_defines.v"


















































































`timescale 1ns / 10ps



























































































`line 79 "\\Sugawara-islfkk\verilog\ac97\ac97_ctrl\rtl\verilog\ac97_top.v"


module ac97_top(clk_i, rst_i,

	wb_data_i, wb_data_o, wb_addr_i, wb_sel_i, wb_we_i, wb_cyc_i,
	wb_stb_i, wb_ack_o, wb_err_o, 

	int_o, dma_req_o, dma_ack_i,
	suspended_o,

	bit_clk_pad_i, sync_pad_o, sdata_pad_o, sdata_pad_i,
	ac97_reset_pad_o_
	);

input		clk_i, rst_i;



input	[31:0]	wb_data_i;
output	[31:0]	wb_data_o;
input	[31:0]	wb_addr_i;
input	[3:0]	wb_sel_i;
input		wb_we_i;
input		wb_cyc_i;
input		wb_stb_i;
output		wb_ack_o;
output		wb_err_o;



output		int_o;
output	[8:0]	dma_req_o;
input	[8:0]	dma_ack_i;



output		suspended_o;



input		bit_clk_pad_i;
output		sync_pad_o;
output		sdata_pad_o;
input		sdata_pad_i;
output		ac97_reset_pad_o_;







wire	[15:0]	out_slt0;
wire	[19:0]	out_slt1;
wire	[19:0]	out_slt2;
wire	[19:0]	out_slt3;
wire	[19:0]	out_slt4;
wire	[19:0]	out_slt6;
wire	[19:0]	out_slt7;
wire	[19:0]	out_slt8;
wire	[19:0]	out_slt9;


wire	[15:0]	in_slt0;
wire	[19:0]	in_slt1;
wire	[19:0]	in_slt2;
wire	[19:0]	in_slt3;
wire	[19:0]	in_slt4;
wire	[19:0]	in_slt6;


wire		ld;
wire		valid;
wire	[5:0]	out_le;
wire	[2:0]	in_valid;
wire		ps_ce;


reg		valid_s1, valid_s;
reg	[2:0]	in_valid_s1, in_valid_s;


wire	[31:0]	wb_din;
wire	[1:0]	o3_mode, o4_mode, o6_mode, o7_mode, o8_mode, o9_mode;
wire		o3_re, o4_re, o6_re, o7_re, o8_re, o9_re;
wire		o3_we, o4_we, o6_we, o7_we, o8_we, o9_we;
wire	[1:0]	o3_status, o4_status, o6_status, o7_status, o8_status, o9_status;
wire		o3_full, o4_full, o6_full, o7_full, o8_full, o9_full;
wire		o3_empty, o4_empty, o6_empty, o7_empty, o8_empty, o9_empty;


wire	[31:0]	i3_dout, i4_dout, i6_dout;
wire	[1:0]	i3_mode, i4_mode, i6_mode;
wire		i3_we, i4_we, i6_we;
wire		i3_re, i4_re, i6_re;
wire	[1:0]	i3_status, i4_status, i6_status;
wire		i3_full, i4_full, i6_full;
wire		i3_empty, i4_empty, i6_empty;


wire	[3:0]	adr;
wire	[31:0]	rf_dout;
wire	[31:0]	rf_din;
wire		rf_we;
wire		rf_re;
wire		ac97_rst_force;
wire		resume_req;
wire		crac_we;
wire	[15:0]	crac_din;
wire	[31:0]	crac_out;
wire	[7:0]	oc0_cfg;
wire	[7:0]	oc1_cfg;
wire	[7:0]	oc2_cfg;
wire	[7:0]	oc3_cfg;
wire	[7:0]	oc4_cfg;
wire	[7:0]	oc5_cfg;
wire	[7:0]	ic0_cfg;
wire	[7:0]	ic1_cfg;
wire	[7:0]	ic2_cfg;
wire	[2:0]	oc0_int_set;
wire	[2:0]	oc1_int_set;
wire	[2:0]	oc2_int_set;
wire	[2:0]	oc3_int_set;
wire	[2:0]	oc4_int_set;
wire	[2:0]	oc5_int_set;
wire	[2:0]	ic0_int_set;
wire	[2:0]	ic1_int_set;
wire	[2:0]	ic2_int_set;


wire		crac_valid;
wire		crac_wr;
wire		crac_wr_done, crac_rd_done;







always @(posedge clk_i)
	valid_s1 <= #1 valid;

always @(posedge clk_i)
	valid_s <= #1 valid_s1;

always @(posedge clk_i)
	in_valid_s1 <= #1 in_valid;

always @(posedge clk_i)
	in_valid_s <= #1 in_valid_s1;



assign o3_mode = oc0_cfg[3:2];
assign o4_mode = oc1_cfg[3:2];
assign o6_mode = oc2_cfg[3:2];
assign o7_mode = oc3_cfg[3:2];
assign o8_mode = oc4_cfg[3:2];
assign o9_mode = oc5_cfg[3:2];
assign i3_mode = ic0_cfg[3:2];
assign i4_mode = ic1_cfg[3:2];
assign i6_mode = ic2_cfg[3:2];






ac97_sout	u0(
		.clk(		bit_clk_pad_i	),
		.rst(		rst_i		),
		.so_ld(		ld		),
		.slt0(		out_slt0	),
		.slt1(		out_slt1	),
		.slt2(		out_slt2	),
		.slt3(		out_slt3	),
		.slt4(		out_slt4	),
		.slt6(		out_slt6	),
		.slt7(		out_slt7	),
		.slt8(		out_slt8	),
		.slt9(		out_slt9	),
		.sdata_out(	sdata_pad_o	)
		);

ac97_sin	u1(
		.clk(		bit_clk_pad_i	),
		.rst(		rst_i		),
		.out_le(	out_le		),
		.slt0(		in_slt0		),
		.slt1(		in_slt1		),
		.slt2(		in_slt2		),
		.slt3(		in_slt3		),
		.slt4(		in_slt4		),
		.slt6(		in_slt6		),
		.sdata_in(	sdata_pad_i	)
		);

ac97_soc	u2(
		.clk(		bit_clk_pad_i	),
		.wclk(		clk_i		),
		.rst(		rst_i		),
		.ps_ce(		ps_ce		),
		.resume(	resume_req	),
		.suspended(	suspended_o	),
		.sync(		sync_pad_o	),
		.out_le(	out_le		),
		.in_valid(	in_valid	),
		.ld(		ld		),
		.valid(		valid		)
		);

ac97_out_fifo	u3(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.en(		oc0_cfg[0]	),
		.mode(		o3_mode		),
		.din(		wb_din		),
		.we(		o3_we		),
		.dout(		out_slt3	),
		.re(		o3_re		),
		.status(	o3_status	),
		.full(		o3_full		),
		.empty(		o3_empty	)
		);

ac97_out_fifo	u4(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.en(		oc1_cfg[0]	),
		.mode(		o4_mode		),
		.din(		wb_din		),
		.we(		o4_we		),
		.dout(		out_slt4	),
		.re(		o4_re		),
		.status(	o4_status	),
		.full(		o4_full		),
		.empty(		o4_empty	)
		);


ac97_out_fifo	u5(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.en(		oc2_cfg[0]	),
		.mode(		o6_mode		),
		.din(		wb_din		),
		.we(		o6_we		),
		.dout(		out_slt6	),
		.re(		o6_re		),
		.status(	o6_status	),
		.full(		o6_full		),
		.empty(		o6_empty	)
		);








ac97_out_fifo	u6(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.en(		oc3_cfg[0]	),
		.mode(		o7_mode		),
		.din(		wb_din		),
		.we(		o7_we		),
		.dout(		out_slt7	),
		.re(		o7_re		),
		.status(	o7_status	),
		.full(		o7_full		),
		.empty(		o7_empty	)
		);

ac97_out_fifo	u7(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.en(		oc4_cfg[0]	),
		.mode(		o8_mode		),
		.din(		wb_din		),
		.we(		o8_we		),
		.dout(		out_slt8	),
		.re(		o8_re		),
		.status(	o8_status	),
		.full(		o8_full		),
		.empty(		o8_empty	)
		);












ac97_out_fifo	u8(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.en(		oc5_cfg[0]	),
		.mode(		o9_mode		),
		.din(		wb_din		),
		.we(		o9_we		),
		.dout(		out_slt9	),
		.re(		o9_re		),
		.status(	o9_status	),
		.full(		o9_full		),
		.empty(		o9_empty	)
		);








ac97_in_fifo	u9(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.en(		ic0_cfg[0]	),
		.mode(		i3_mode		),
		.din(		in_slt3		),
		.we(		i3_we		),
		.dout(		i3_dout		),
		.re(		i3_re		),
		.status(	i3_status	),
		.full(		i3_full		),
		.empty(		i3_empty	)
		);

ac97_in_fifo	u10(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.en(		ic1_cfg[0]	),
		.mode(		i4_mode		),
		.din(		in_slt4		),
		.we(		i4_we		),
		.dout(		i4_dout		),
		.re(		i4_re		),
		.status(	i4_status	),
		.full(		i4_full		),
		.empty(		i4_empty	)
		);












ac97_in_fifo	u11(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.en(		ic2_cfg[0]	),
		.mode(		i6_mode		),
		.din(		in_slt6		),
		.we(		i6_we		),
		.dout(		i6_dout		),
		.re(		i6_re		),
		.status(	i6_status	),
		.full(		i6_full		),
		.empty(		i6_empty	)
		);







ac97_wb_if	u12(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.wb_data_i(	wb_data_i	),
		.wb_data_o(	wb_data_o	),
		.wb_addr_i(	wb_addr_i	),
		.wb_sel_i(	wb_sel_i	),
		.wb_we_i(	wb_we_i		),
		.wb_cyc_i(	wb_cyc_i	),
		.wb_stb_i(	wb_stb_i	),
		.wb_ack_o(	wb_ack_o	),
		.wb_err_o(	wb_err_o	),
		.adr(		adr		),
		.dout(		wb_din		),
		.rf_din(	rf_dout		),
		.i3_din(	i3_dout		),
		.i4_din(	i4_dout		),
		.i6_din(	i6_dout		),
		.rf_we(		rf_we		),
		.rf_re(		rf_re		),
		.o3_we(		o3_we		),
		.o4_we(		o4_we		),
		.o6_we(		o6_we		),
		.o7_we(		o7_we		),
		.o8_we(		o8_we		),
		.o9_we(		o9_we		),
		.i3_re(		i3_re		),
		.i4_re(		i4_re		),
		.i6_re(		i6_re		)
		);

ac97_rf	u13(	.clk(		clk_i		),
		.rst(		rst_i		),
		.adr(		adr		),
		.rf_dout(	rf_dout		),
		.rf_din(	wb_din		),
		.rf_we(		rf_we		),
		.rf_re(		rf_re		),
		.int(		int_o		),
		.ac97_rst_force(ac97_rst_force	),
		.resume_req(	resume_req	),
		.suspended(	suspended_o	),
		.crac_we(	crac_we		),
		.crac_din(	crac_din	),
		.crac_out(	crac_out	),
		.crac_wr_done(	crac_wr_done	),
		.crac_rd_done(	crac_rd_done	),
		.oc0_cfg(	oc0_cfg		),
		.oc1_cfg(	oc1_cfg		),
		.oc2_cfg(	oc2_cfg		),
		.oc3_cfg(	oc3_cfg		),
		.oc4_cfg(	oc4_cfg		),
		.oc5_cfg(	oc5_cfg		),
		.ic0_cfg(	ic0_cfg		),
		.ic1_cfg(	ic1_cfg		),
		.ic2_cfg(	ic2_cfg		),
		.oc0_int_set(	oc0_int_set	),
		.oc1_int_set(	oc1_int_set	),
		.oc2_int_set(	oc2_int_set	),
		.oc3_int_set(	oc3_int_set	),
		.oc4_int_set(	oc4_int_set	),
		.oc5_int_set(	oc5_int_set	),
		.ic0_int_set(	ic0_int_set	),
		.ic1_int_set(	ic1_int_set	),
		.ic2_int_set(	ic2_int_set	)
		);

ac97_prc u14(	.clk(		clk_i		),
		.rst(		rst_i		),
		.valid(		valid_s		),
		.in_valid(	in_valid_s	),
		.out_slt0(	out_slt0	),
		.in_slt0(	in_slt0		),
		.in_slt1(	in_slt1		),
		.crac_valid(	crac_valid	),
		.crac_wr(	crac_wr		),
		.oc0_cfg(	oc0_cfg		),
		.oc1_cfg(	oc1_cfg		),
		.oc2_cfg(	oc2_cfg		),
		.oc3_cfg(	oc3_cfg		),
		.oc4_cfg(	oc4_cfg		),
		.oc5_cfg(	oc5_cfg		),
		.ic0_cfg(	ic0_cfg		),
		.ic1_cfg(	ic1_cfg		),
		.ic2_cfg(	ic2_cfg		),
		.o3_empty(	o3_empty	),
		.o4_empty(	o4_empty	),
		.o6_empty(	o6_empty	),
		.o7_empty(	o7_empty	),
		.o8_empty(	o8_empty	),
		.o9_empty(	o9_empty	),
		.i3_full(	i3_full		),
		.i4_full(	i4_full		),
		.i6_full(	i6_full		),
		.o3_re(		o3_re		),
		.o4_re(		o4_re		),
		.o6_re(		o6_re		),
		.o7_re(		o7_re		),
		.o8_re(		o8_re		),
		.o9_re(		o9_re		),
		.i3_we(		i3_we		),
		.i4_we(		i4_we		),
		.i6_we(		i6_we		)
		);

ac97_cra u15(	.clk(		clk_i		),
		.rst(		rst_i		),
		.crac_we(	crac_we		),
		.crac_din(	crac_din	),
		.crac_out(	crac_out	),
		.crac_wr_done(	crac_wr_done	),
		.crac_rd_done(	crac_rd_done	),
		.valid(		valid_s		),
		.out_slt1(	out_slt1	),
		.out_slt2(	out_slt2	),
		.in_slt2(	in_slt2		),
		.crac_valid(	crac_valid	),
		.crac_wr(	crac_wr		)
		);

ac97_dma_if u16(.clk(		clk_i		),
		.rst(		rst_i		),
		.o3_status(	o3_status	),
		.o4_status(	o4_status	),
		.o6_status(	o6_status	),
		.o7_status(	o7_status	),
		.o8_status(	o8_status	),
		.o9_status(	o9_status	),
		.o3_empty(	o3_empty	),
		.o4_empty(	o4_empty	),
		.o6_empty(	o6_empty	),
		.o7_empty(	o7_empty	),
		.o8_empty(	o8_empty	),
		.o9_empty(	o9_empty	),
		.i3_status(	i3_status	),
		.i4_status(	i4_status	),
		.i6_status(	i6_status	),
		.i3_full(	i3_full		),
		.i4_full(	i4_full		),
		.i6_full(	i6_full		),
		.oc0_cfg(	oc0_cfg		),
		.oc1_cfg(	oc1_cfg		),
		.oc2_cfg(	oc2_cfg		),
		.oc3_cfg(	oc3_cfg		),
		.oc4_cfg(	oc4_cfg		),
		.oc5_cfg(	oc5_cfg		),
		.ic0_cfg(	ic0_cfg		),
		.ic1_cfg(	ic1_cfg		),
		.ic2_cfg(	ic2_cfg		),
		.dma_req(	dma_req_o	),
		.dma_ack(	dma_ack_i	)
		);

ac97_int	u17(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.int_set(	oc0_int_set	),
		.cfg(		oc0_cfg		),
		.status(	o3_status	),
		.full_empty(	o3_empty	),
		.full(		o3_full		),
		.empty(		o3_empty	),
		.re(		o3_re		),
		.we(		o3_we		)
		);

ac97_int	u18(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.int_set(	oc1_int_set	),
		.cfg(		oc1_cfg		),
		.status(	o4_status	),
		.full_empty(	o4_empty	),
		.full(		o4_full		),
		.empty(		o4_empty	),
		.re(		o4_re		),
		.we(		o4_we		)
		);


ac97_int	u19(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.int_set(	oc2_int_set	),
		.cfg(		oc2_cfg		),
		.status(	o6_status	),
		.full_empty(	o6_empty	),
		.full(		o6_full		),
		.empty(		o6_empty	),
		.re(		o6_re		),
		.we(		o6_we		)
		);





ac97_int	u20(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.int_set(	oc3_int_set	),
		.cfg(		oc3_cfg		),
		.status(	o7_status	),
		.full_empty(	o7_empty	),
		.full(		o7_full		),
		.empty(		o7_empty	),
		.re(		o7_re		),
		.we(		o7_we		)
		);

ac97_int	u21(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.int_set(	oc4_int_set	),
		.cfg(		oc4_cfg		),
		.status(	o8_status	),
		.full_empty(	o8_empty	),
		.full(		o8_full		),
		.empty(		o8_empty	),
		.re(		o8_re		),
		.we(		o8_we		)
		);






ac97_int	u22(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.int_set(	oc5_int_set	),
		.cfg(		oc5_cfg		),
		.status(	o9_status	),
		.full_empty(	o9_empty	),
		.full(		o9_full		),
		.empty(		o9_empty	),
		.re(		o9_re		),
		.we(		o9_we		)
		);





ac97_int	u23(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.int_set(	ic0_int_set	),
		.cfg(		ic0_cfg		),
		.status(	i3_status	),
		.full_empty(	i3_full		),
		.full(		i3_full		),
		.empty(		i3_empty	),
		.re(		i3_re		),
		.we(		i3_we		)
		);

ac97_int	u24(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.int_set(	ic1_int_set	),
		.cfg(		ic1_cfg		),
		.status(	i4_status	),
		.full_empty(	i4_full		),
		.full(		i4_full		),
		.empty(		i4_empty	),
		.re(		i4_re		),
		.we(		i4_we		)
		);






ac97_int	u25(
		.clk(		clk_i		),
		.rst(		rst_i		),
		.int_set(	ic2_int_set	),
		.cfg(		ic2_cfg		),
		.status(	i6_status	),
		.full_empty(	i6_full		),
		.full(		i6_full		),
		.empty(		i6_empty	),
		.re(		i6_re		),
		.we(		i6_we		)
		);




ac97_rst	u26(
		.clk(		clk_i				),
		.rst(		rst_i 				),
		.rst_force(	ac97_rst_force			),
		.ps_ce(		ps_ce				),
		.ac97_rst_(	ac97_reset_pad_o_		)
		);

endmodule




